#+clm (in-package :clm)

;;; import all sndlib names to CLM

#+(and excl (not allegro-v7.0)) (require :foreign)
#+cmu (use-package "ALIEN")
;#+cmu (use-package "C-CALL")
#+openmcl (defun get-cstring (str) (when (not (ccl:%null-ptr-p str)) (%get-cstring str)))

#+cmu (def-alien-routine ("mus_error_to_string" mus-error-to-string) c-call:c-string (err c-call:int))
#+sbcl (sb-alien:define-alien-routine ("mus_error_to_string" mus-error-to-string) sb-alien:c-string (err sb-alien:int))
#+allegro-v5.0 (ff:def-foreign-call (mus-error-to-string-1 "mus_error_to_string") ((err :int)) :returning :int)
#+allegro-v5.0 (defun mus-error-to-string (name) (let ((ptr (mus-error-to-string-1 name))) (ff:char*-to-string ptr)))
#+(or allegro-v6.0 allegro-v6.1 allegro-v6.2) (ff:def-foreign-call (mus-error-to-string "mus_error_to_string") ((err :int)) :returning ((* :char)))
#+allegro-v7.0 (ff:def-foreign-call (mus-error-to-string "mus_error_to_string") ((err :int)) :strings-convert t :returning ((* :char)))
#+openmcl (defun mus-error-to-string (err) (get-cstring (ccl::external-call "_mus_error_to_string" :signed err :address)))

#+cmu (def-alien-routine ("clm_sound_samples" mus-sound-samples) c-call:int (arg c-call:c-string))
#+sbcl (sb-alien:define-alien-routine ("clm_sound_samples" mus-sound-samples) sb-alien:int (arg sb-alien:c-string))
#+allegro-v5.0 (ff:def-foreign-call (mus-sound-samples "clm_sound_samples") ((arg (* :char) string)) :returning :int)
#+(or allegro-v6.0 allegro-v6.1 allegro-v6.2) (ff:def-foreign-call (mus-sound-samples "clm_sound_samples") ((arg (* :char))) :returning :int)
#+allegro-v7.0 (ff:def-foreign-call (mus-sound-samples "clm_sound_samples") ((arg (* :char))) :strings-convert t :returning :int)
#+openmcl (defun mus-sound-samples (file) (ccl:with-cstrs ((f file)) (ccl::external-call "_mus_sound_samples" :address f (:signed 64))))

#+cmu (def-alien-routine ("clm_sound_frames" mus-sound-frames) c-call:int (arg c-call:c-string))
#+sbcl (sb-alien:define-alien-routine ("clm_sound_frames" mus-sound-frames) sb-alien:int (arg sb-alien:c-string))
#+allegro-v5.0 (ff:def-foreign-call (mus-sound-frames "clm_sound_frames") ((arg (* :char) string)) :returning :int)
#+(or allegro-v6.0 allegro-v6.1 allegro-v6.2) (ff:def-foreign-call (mus-sound-frames "clm_sound_frames") ((arg (* :char))) :returning :int)
#+allegro-v7.0 (ff:def-foreign-call (mus-sound-frames "clm_sound_frames") ((arg (* :char))) :strings-convert t :returning :int)
#+openmcl (defun mus-sound-frames (file) (ccl:with-cstrs ((f file)) (ccl::external-call "_mus_sound_frames" :address f (:signed 64))))

#+cmu (def-alien-routine ("mus_sound_datum_size" mus-sound-datum-size) c-call:int (arg c-call:c-string))
#+sbcl (sb-alien:define-alien-routine ("mus_sound_datum_size" mus-sound-datum-size) sb-alien:int (arg sb-alien:c-string))
#+allegro-v5.0 (ff:def-foreign-call (mus-sound-datum-size "mus_sound_datum_size") ((arg (* :char) string)) :returning :int)
#+(or allegro-v6.0 allegro-v6.1 allegro-v6.2) (ff:def-foreign-call (mus-sound-datum-size "mus_sound_datum_size") ((arg (* :char))) :returning :int)
#+allegro-v7.0 (ff:def-foreign-call (mus-sound-datum-size "mus_sound_datum_size") ((arg (* :char))) :strings-convert t :returning :int)
#+openmcl (defun mus-sound-datum-size (file) (ccl:with-cstrs ((f file)) (ccl::external-call "_mus_sound_datum_size" :address f :signed)))

#+cmu (def-alien-routine ("clm_sound_data_location" mus-sound-data-location) c-call:int (arg c-call:c-string))
#+sbcl (sb-alien:define-alien-routine ("clm_sound_data_location" mus-sound-data-location) sb-alien:int (arg sb-alien:c-string))
#+allegro-v5.0 (ff:def-foreign-call (mus-sound-data-location "clm_sound_data_location") ((arg (* :char) string)) :returning :int)
#+(or allegro-v6.0 allegro-v6.1 allegro-v6.2) (ff:def-foreign-call (mus-sound-data-location "clm_sound_data_location") ((arg (* :char))) :returning :int)
#+allegro-v7.0 (ff:def-foreign-call (mus-sound-data-location "clm_sound_data_location") ((arg (* :char))) :strings-convert t :returning :int)
#+openmcl (defun mus-sound-data-location (file) (ccl:with-cstrs ((f file)) (ccl::external-call "_mus_sound_data_location" :address f (:signed 64))))

#+cmu (def-alien-routine ("mus_sound_chans" mus-sound-chans) c-call:int (arg c-call:c-string))
#+sbcl (sb-alien:define-alien-routine ("mus_sound_chans" mus-sound-chans) sb-alien:int (arg sb-alien:c-string))
#+allegro-v5.0 (ff:def-foreign-call (mus-sound-chans "mus_sound_chans") ((arg (* :char) string)) :returning :int)
#+(or allegro-v6.0 allegro-v6.1 allegro-v6.2) (ff:def-foreign-call (mus-sound-chans "mus_sound_chans") ((arg (* :char))) :returning :int)
#+allegro-v7.0 (ff:def-foreign-call (mus-sound-chans "mus_sound_chans") ((arg (* :char))) :strings-convert t :returning :int)
#+openmcl (defun mus-sound-chans (file) (ccl:with-cstrs ((f file)) (ccl::external-call "_mus_sound_chans" :address f :signed)))

#+cmu (def-alien-routine ("mus_sound_srate" mus-sound-srate) c-call:int (arg c-call:c-string))
#+sbcl (sb-alien:define-alien-routine ("mus_sound_srate" mus-sound-srate) sb-alien:int (arg sb-alien:c-string))
#+allegro-v5.0 (ff:def-foreign-call (mus-sound-srate "mus_sound_srate") ((arg (* :char) string)) :returning :int)
#+(or allegro-v6.0 allegro-v6.1 allegro-v6.2) (ff:def-foreign-call (mus-sound-srate "mus_sound_srate") ((arg (* :char))) :returning :int)
#+allegro-v7.0 (ff:def-foreign-call (mus-sound-srate "mus_sound_srate") ((arg (* :char))) :strings-convert t :returning :int)
#+openmcl (defun mus-sound-srate (file) (ccl:with-cstrs ((f file)) (ccl::external-call "_mus_sound_srate" :address f :signed)))

#+cmu (def-alien-routine ("mus_sound_header_type" mus-sound-header-type) c-call:int (arg c-call:c-string))
#+sbcl (sb-alien:define-alien-routine ("mus_sound_header_type" mus-sound-header-type) sb-alien:int (arg sb-alien:c-string))
#+allegro-v5.0 (ff:def-foreign-call (mus-sound-header-type "mus_sound_header_type") ((arg (* :char) string)) :returning :int)
#+(or allegro-v6.0 allegro-v6.1 allegro-v6.2) (ff:def-foreign-call (mus-sound-header-type "mus_sound_header_type") ((arg (* :char))) :returning :int)
#+allegro-v7.0 (ff:def-foreign-call (mus-sound-header-type "mus_sound_header_type") ((arg (* :char))) :strings-convert t :returning :int)
#+openmcl (defun mus-sound-header-type (file) (ccl:with-cstrs ((f file)) (ccl::external-call "_mus_sound_header_type" :address f :signed)))

#+cmu (def-alien-routine ("mus_sound_data_format" mus-sound-data-format) c-call:int (arg c-call:c-string))
#+sbcl (sb-alien:define-alien-routine ("mus_sound_data_format" mus-sound-data-format) sb-alien:int (arg sb-alien:c-string))
#+allegro-v5.0 (ff:def-foreign-call (mus-sound-data-format "mus_sound_data_format") ((arg (* :char) string)) :returning :int)
#+(or allegro-v6.0 allegro-v6.1 allegro-v6.2) (ff:def-foreign-call (mus-sound-data-format "mus_sound_data_format") ((arg (* :char))) :returning :int)
#+allegro-v7.0 (ff:def-foreign-call (mus-sound-data-format "mus_sound_data_format") ((arg (* :char))) :strings-convert t :returning :int)
#+openmcl (defun mus-sound-data-format (file) (ccl:with-cstrs ((f file)) (ccl::external-call "_mus_sound_data_format" :address f :signed)))

#+cmu (def-alien-routine ("mus_sound_original_format" mus-sound-original-format) c-call:int (arg c-call:c-string))
#+sbcl (sb-alien:define-alien-routine ("mus_sound_original_format" mus-sound-original-format) sb-alien:int (arg sb-alien:c-string))
#+allegro-v5.0 (ff:def-foreign-call (mus-sound-original-format "mus_sound_original_format") ((arg (* :char) string)) :returning :int)
#+(or allegro-v6.0 allegro-v6.1 allegro-v6.2) (ff:def-foreign-call (mus-sound-original-format "mus_sound_original_format") ((arg (* :char))) :returning :int)
#+allegro-v7.0 (ff:def-foreign-call (mus-sound-original-format "mus_sound_original_format") ((arg (* :char))) :strings-convert t :returning :int)
#+openmcl (defun mus-sound-original-format (file) (ccl:with-cstrs ((f file)) (ccl::external-call "_mus_sound_original_format" :address f :signed)))

#+cmu (def-alien-routine ("mus_sound_write_date" mus-sound-write-date) c-call:int (arg c-call:c-string))
#+sbcl (sb-alien:define-alien-routine ("mus_sound_write_date" mus-sound-write-date) sb-alien:int (arg sb-alien:c-string))
#+allegro-v5.0 (ff:def-foreign-call (mus-sound-write-date "mus_sound_write_date") ((arg (* :char) string)) :returning :int)
#+(or allegro-v6.0 allegro-v6.1 allegro-v6.2) (ff:def-foreign-call (mus-sound-write-date "mus_sound_write_date") ((arg (* :char))) :returning :int)
#+allegro-v7.0 (ff:def-foreign-call (mus-sound-write-date "mus_sound_write_date") ((arg (* :char))) :strings-convert t :returning :int)
#+openmcl (defun mus-sound-write-date (file) (ccl:with-cstrs ((f file)) (ccl::external-call "_mus_sound_write_date" :address f :signed)))

#+cmu (def-alien-routine ("mus_sound_comment_start" mus-sound-comment-start) c-call:int (arg c-call:c-string))
#+sbcl (sb-alien:define-alien-routine ("mus_sound_comment_start" mus-sound-comment-start) sb-alien:int (arg sb-alien:c-string))
#+allegro-v5.0 (ff:def-foreign-call (mus-sound-comment-start "mus_sound_comment_start") ((arg (* :char) string)) :returning :int)
#+(or allegro-v6.0 allegro-v6.1 allegro-v6.2) (ff:def-foreign-call (mus-sound-comment-start "mus_sound_comment_start") ((arg (* :char))) :returning :int)
#+allegro-v7.0 (ff:def-foreign-call (mus-sound-comment-start "mus_sound_comment_start") ((arg (* :char))) :strings-convert t :returning :int)
#+openmcl (defun mus-sound-comment-start (file) (ccl:with-cstrs ((f file)) (ccl::external-call "_mus_sound_comment_start" :address f :signed)))

#+cmu (def-alien-routine ("mus_sound_comment_end" mus-sound-comment-end) c-call:int (arg c-call:c-string))
#+sbcl (sb-alien:define-alien-routine ("mus_sound_comment_end" mus-sound-comment-end) sb-alien:int (arg sb-alien:c-string))
#+allegro-v5.0 (ff:def-foreign-call (mus-sound-comment-end "mus_sound_comment_end") ((arg (* :char) string)) :returning :int)
#+(or allegro-v6.0 allegro-v6.1 allegro-v6.2) (ff:def-foreign-call (mus-sound-comment-end "mus_sound_comment_end") ((arg (* :char))) :returning :int)
#+allegro-v7.0 (ff:def-foreign-call (mus-sound-comment-end "mus_sound_comment_end") ((arg (* :char))) :strings-convert t :returning :int)
#+openmcl (defun mus-sound-comment-end (file) (ccl:with-cstrs ((f file)) (ccl::external-call "_mus_sound_comment_end" :address f :signed)))

#+cmu (def-alien-routine ("clm_sound_length" mus-sound-length) c-call:int (arg c-call:c-string))
#+sbcl (sb-alien:define-alien-routine ("clm_sound_length" mus-sound-length) sb-alien:int (arg sb-alien:c-string))
#+allegro-v5.0 (ff:def-foreign-call (clm-sound-length "mus_sound_length") ((arg (* :char) string)) :returning :int)
#+(or allegro-v6.0 allegro-v6.1 allegro-v6.2) (ff:def-foreign-call (clm-sound-length "mus_sound_length") ((arg (* :char))) :returning :int)
#+allegro-v7.0 (ff:def-foreign-call (clm-sound-length "mus_sound_length") ((arg (* :char))) :strings-convert t :returning :int)
#+openmcl (defun mus-sound-length (file) (ccl:with-cstrs ((f file)) (ccl::external-call "_mus_sound_length" :address f (:signed 64))))

#+cmu (def-alien-routine ("mus_sound_type_specifier" mus-sound-type-specifier) c-call:int (arg c-call:c-string))
#+sbcl (sb-alien:define-alien-routine ("mus_sound_type_specifier" mus-sound-type-specifier) sb-alien:int (arg sb-alien:c-string))
#+allegro-v5.0 (ff:def-foreign-call (mus-sound-type-specifier "mus_sound_type_specifier") ((arg (* :char) string)) :returning :int)
#+(or allegro-v6.0 allegro-v6.1 allegro-v6.2) (ff:def-foreign-call (mus-sound-type-specifier "mus_sound_type_specifier") ((arg (* :char))) :returning :int)
#+allegro-v7.0 (ff:def-foreign-call (mus-sound-type-specifier "mus_sound_type_specifier") ((arg (* :char))) :strings-convert t :returning :int)
#+openmcl (defun mus-sound-type-specifier (file) (ccl:with-cstrs ((f file)) (ccl::external-call "_mus_sound_type_specifier" :address f :signed)))

#+cmu (def-alien-routine ("mus_sound_bits_per_sample" mus-sound-bits-per-sample) c-call:int (arg c-call:c-string))
#+sbcl (sb-alien:define-alien-routine ("mus_sound_bits_per_sample" mus-sound-bits-per-sample) sb-alien:int (arg sb-alien:c-string))
#+allegro-v5.0 (ff:def-foreign-call (mus-sound-bits-per-sample "mus_sound_bits_per_sample") ((arg (* :char) string)) :returning :int)
#+(or allegro-v6.0 allegro-v6.1 allegro-v6.2) (ff:def-foreign-call (mus-sound-bits-per-sample "mus_sound_bits_per_sample") ((arg (* :char))) :returning :int)
#+allegro-v7.0 (ff:def-foreign-call (mus-sound-bits-per-sample "mus_sound_bits_per_sample") ((arg (* :char))) :strings-convert t :returning :int)
#+openmcl (defun mus-sound-bits-per-sample (file) (ccl:with-cstrs ((f file)) (ccl::external-call "_mus_sound_bits_per_sample" :address f :signed)))

#+cmu (def-alien-routine ("mus_header_type_name" mus-header-type-name) c-call:c-string (type c-call:int))
#+sbcl (sb-alien:define-alien-routine ("mus_header_type_name" mus-header-type-name) sb-alien:c-string (type sb-alien:int))
#+allegro-v5.0 (ff:def-foreign-call (mus-header-type-name-1 "mus_header_type_name") ((type :int)) :returning :int)
#+allegro-v5.0 (defun mus-header-type-name (name) (let ((ptr (mus-header-type-name-1 name))) (ff:char*-to-string ptr)))
#+(or allegro-v6.0 allegro-v6.1 allegro-v6.2) (ff:def-foreign-call (mus-header-type-name "mus_header_type_name") ((type :int)) :returning ((* :char)))
#+allegro-v7.0 (ff:def-foreign-call (mus-header-type-name "mus_header_type_name") ((type :int)) :strings-convert t :returning ((* :char)))
#+openmcl (defun mus-header-type-name (typ) (get-cstring (ccl::external-call "_mus_header_type_name" :signed typ :address)))

#+cmu (def-alien-routine ("mus_data_format_name" mus-data-format-name) c-call:c-string (format c-call:int))
#+sbcl (sb-alien:define-alien-routine ("mus_data_format_name" mus-data-format-name) sb-alien:c-string (format sb-alien:int))
#+allegro-v5.0 (ff:def-foreign-call (mus-data-format-name-1 "mus_data_format_name") ((format :int)) :returning :int)
#+allegro-v5.0 (defun mus-data-format-name (name) (let ((ptr (mus-data-format-name-1 name))) (ff:char*-to-string ptr)))
#+(or allegro-v6.0 allegro-v6.1 allegro-v6.2) (ff:def-foreign-call (mus-data-format-name "mus_data_format_name") ((format :int)) :returning ((* :char)))
#+allegro-v7.0 (ff:def-foreign-call (mus-data-format-name "mus_data_format_name") ((format :int)) :strings-convert t :returning ((* :char)))
#+openmcl (defun mus-header-format-name (typ) (get-cstring (ccl::external-call "_mus_header_format_name" :signed typ :address)))

#+cmu (def-alien-routine ("mus_sound_comment" mus-sound-comment) c-call:c-string (name c-call:c-string))
#+sbcl (sb-alien:define-alien-routine ("mus_sound_comment" mus-sound-comment) sb-alien:c-string (name sb-alien:c-string))
#+allegro-v5.0 (ff:def-foreign-call (mus-sound-comment-1 "mus_sound_comment") ((name (* :char) string)) :returning :int)
#+allegro-v5.0 (defun mus-sound-comment (name) (let ((ptr (mus-sound-comment-1 name))) (ff:char*-to-string ptr)))
#+(or allegro-v6.0 allegro-v6.1 allegro-v6.2) (ff:def-foreign-call (mus-sound-comment "mus_sound_comment") ((name (* :char))) :returning ((* :char)))
#+allegro-v7.0 (ff:def-foreign-call (mus-sound-comment "mus_sound_comment") ((name (* :char))) :strings-convert t :returning ((* :char)))
#+openmcl (defun mus-sound-comment (file) (ccl:with-cstrs ((f file)) (get-cstring (ccl::external-call "_mus_sound_comment" :address f :address))))

#+cmu (def-alien-routine ("mus_bytes_per_sample" mus-data-format-to-bytes-per-sample) c-call:int (format c-call:int))
#+sbcl (sb-alien:define-alien-routine ("mus_bytes_per_sample" mus-data-format-to-bytes-per-sample) sb-alien:int (format sb-alien:int))
#+allegro-v5.0 (ff:def-foreign-call (mus-data-format-to-bytes-per-sample "mus_bytes_per_sample") ((format :int)) :returning :int)
#+(or allegro-v6.0 allegro-v6.1 allegro-v6.2) (ff:def-foreign-call (mus-data-format-to-bytes-per-sample "mus_bytes_per_sample") ((format :int)) :returning :int)
#+allegro-v7.0 (ff:def-foreign-call (mus-data-format-to-bytes-per-sample "mus_bytes_per_sample") ((format :int)) :strings-convert t :returning :int)
#+openmcl (defun mus-data-format-to-bytes-per-sample (format) (ccl::external-call "_mus_bytes_per_sample" :signed format :signed))

#+cmu (def-alien-routine ("mus_sound_duration" mus-sound-duration) double-float (arg c-call:c-string))
#+sbcl (sb-alien:define-alien-routine ("mus_sound_duration" mus-sound-duration) double-float (arg sb-alien:c-string))
#+allegro-v5.0 (ff:def-foreign-call (mus-sound-duration "mus_sound_duration") ((arg (* :char) string)) :returning :float)
#+(or allegro-v6.0 allegro-v6.1 allegro-v6.2) (ff:def-foreign-call (mus-sound-duration "mus_sound_duration") ((arg (* :char))) :returning :float)
#+allegro-v7.0 (ff:def-foreign-call (mus-sound-duration "mus_sound_duration") ((arg (* :char))) :strings-convert t :returning :float)
#+opencml (defun mus-sound-duration (file) (ccl:with-cstrs ((f file)) (ccl::external-call "_mus_sound_duration" :address f :single-float)))

#+cmu (def-alien-routine ("mus_sound_initialize" mus-sound-initialize) c-call:int )
#+sbcl (sb-alien:define-alien-routine ("mus_sound_initialize" mus-sound-initialize) sb-alien:int )
#+allegro-v5.0 (ff:def-foreign-call (mus-sound-initialize "mus_sound_initialize") (:void) :returning :int)
#+(or allegro-v6.0 allegro-v6.1 allegro-v6.2) (ff:def-foreign-call (mus-sound-initialize "mus_sound_initialize") (:void) :returning :int)
#+allegro-v7.0 (ff:def-foreign-call (mus-sound-initialize "mus_sound_initialize") (:void) :strings-convert t :returning :int)
#+openmcl (defun mus-sound-initialize () (ccl::external-call "_mus_sound_initialize" :signed))

#+cmu (def-alien-routine ("mus_sample_bits" mus-sample-bits) c-call:int )
#+sbcl (sb-alien:define-alien-routine ("mus_sample_bits" mus-sample-bits) sb-alien:int )
#+allegro-v5.0 (ff:def-foreign-call (mus-sample-bits "mus_sample_bits") (:void) :returning :int)
#+(or allegro-v6.0 allegro-v6.1 allegro-v6.2) (ff:def-foreign-call (mus-sample-bits "mus_sample_bits") (:void) :returning :int)
#+allegro-v7.0 (ff:def-foreign-call (mus-sample-bits "mus_sample_bits") (:void) :strings-convert t :returning :int)
#+openmcl (defun mus-sample-bits () (ccl::external-call "_mus_sample_bits" :signed))

#+cmu (def-alien-routine ("mus_sound_override_header" mus-sound-override-header) c-call:int (arg c-call:c-string) (srate c-call:int) (chans c-call:int) (format c-call:int) (type c-call:int) (location c-call:int) (size c-call:int))
#+sbcl (sb-alien:define-alien-routine ("mus_sound_override_header" mus-sound-override-header) sb-alien:int (arg sb-alien:c-string) (srate sb-alien:int) (chans sb-alien:int) (format sb-alien:int) (type sb-alien:int) (location sb-alien:int) (size sb-alien:int))
#+allegro-v5.0 (ff:def-foreign-call (mus-sound-override-header "mus_sound_override_header") ((arg (* :char) string) (srate :int) (chans :int) (format :int) (type :int) (location :int) (size :int)) :returning :int)
#+(or allegro-v6.0 allegro-v6.1 allegro-v6.2) (ff:def-foreign-call (mus-sound-override-header "mus_sound_override_header") ((arg (* :char)) (srate :int) (chans :int) (format :int) (type :int) (location :int) (size :int)) :returning :int)
#+allegro-v7.0 (ff:def-foreign-call (mus-sound-override-header "mus_sound_override_header") ((arg (* :char)) (srate :int) (chans :int) (format :int) (type :int) (location :int) (size :int)) :strings-convert t :returning :int)
#+openmcl (defun mus-sound-override-header (name srate chans format type location size)
	    (ccl:with-cstrs ((f name))
	      (ccl::external-call "_mus_sound_override_header"
				  :address f :signed srate :signed chans :signed format :signed type (:signed 64) location (:signed 64) size :signed)))

#+cmu (def-alien-routine ("mus_sound_forget" mus-sound-forget) c-call:int (name c-call:c-string))
#+sbcl (sb-alien:define-alien-routine ("mus_sound_forget" mus-sound-forget) sb-alien:int (name sb-alien:c-string))
#+allegro-v5.0 (ff:def-foreign-call (mus-sound-forget "mus_sound_forget") ((name (* :char) string)) :returning :int)
#+(or allegro-v6.0 allegro-v6.1 allegro-v6.2) (ff:def-foreign-call (mus-sound-forget "mus_sound_forget") ((name (* :char))) :returning :int)
#+allegro-v7.0 (ff:def-foreign-call (mus-sound-forget "mus_sound_forget") ((name (* :char))) :strings-convert t :returning :int)
#+opencml (defun mus-sound-forget (file) (ccl:with-cstrs ((f file)) (ccl::external-call "_mus_sound_forget" :address f :signed)))

;;; #+cmu (def-alien-routine ("mus_sound_loop_info" c-call:int mus-sound-loop-info) (arg c-call:c-string))
;;sbcl+csb-alien:mu ine(def-alien-routine ("mus_sound_loop_info" sb-alien:int mus-sound-loop-info) (arg sb-alien:c-string))
;;;   returns an c-call:int array -- how to declare that for cmucl?
#+allegro-v5.0 (ff:def-foreign-call (mus-sound-loop-info-1 "mus_sound_loop_info") ((arg (* :char) string)) :returning :int)
#+allegro-v5.0 (defun mus-sound-loop-info (name) (let ((ptr (mus-sound-loop-info-1 name))) (ff:char*-to-string ptr)))
#+(or allegro-v6.0 allegro-v6.1 allegro-v6.2) (ff:def-foreign-call (mus-sound-loop-info "mus_sound_loop_info") ((arg (* :char))) :returning ((* :int)))
#+allegro-v7.0 (ff:def-foreign-call (mus-sound-loop-info "mus_sound_loop_info") ((arg (* :char))) :strings-convert t :returning ((* :int)))
;;; openmcl returning array?

#+cmu (def-alien-routine ("mus_sound_open_input" mus-sound-open-input) c-call:int (arg c-call:c-string))
#+sbcl (sb-alien:define-alien-routine ("mus_sound_open_input" mus-sound-open-input) sb-alien:int (arg sb-alien:c-string))
#+allegro-v5.0 (ff:def-foreign-call (mus-sound-open-input "mus_sound_open_input") ((arg (* :char) string)) :returning :int)
#+(or allegro-v6.0 allegro-v6.1 allegro-v6.2) (ff:def-foreign-call (mus-sound-open-input "mus_sound_open_input") ((arg (* :char))) :returning :int)
#+allegro-v7.0 (ff:def-foreign-call (mus-sound-open-input "mus_sound_open_input") ((arg (* :char))) :strings-convert t :returning :int)
#+openmcl (defun mus-sound-open-input (file) (ccl:with-cstrs ((f file)) (ccl::external-call "_mus_sound_open_input" :address f :signed)))

#+cmu (def-alien-routine ("mus_sound_open_output" mus-sound-open-output) c-call:int
	(arg c-call:c-string) (srate c-call:int) (chans c-call:int) (data-format c-call:int) (header-type c-call:int) (comment c-call:c-string))
#+sbcl (sb-alien:define-alien-routine ("mus_sound_open_output" mus-sound-open-output) sb-alien:int
	(arg sb-alien:c-string) (srate sb-alien:int) (chans sb-alien:int) (data-format sb-alien:int) (header-type sb-alien:int) (comment sb-alien:c-string))
#+allegro-v5.0 (ff:def-foreign-call (mus-sound-open-output "mus_sound_open_output")
				    ((arg (* :char) string) (srate :int) (chans :int) (data-format :int) (header-type :int) (comment (* :char) string))
				    :returning :int)
#+(or allegro-v6.0 allegro-v6.1 allegro-v6.2) (ff:def-foreign-call (mus-sound-open-output "mus_sound_open_output")
				    ((arg (* :char)) (srate :int) (chans :int) (data-format :int) (header-type :int) (comment (* :char)))
				    :returning :int)
#+allegro-v7.0 (ff:def-foreign-call (mus-sound-open-output "mus_sound_open_output")
				    ((arg (* :char)) (srate :int) (chans :int) (data-format :int) (header-type :int) (comment (* :char)))
				    :strings-convert t :returning :int)
#+openmcl (defun mus-sound-open-output (name srate chans format type comment)
	    (ccl:with-cstrs ((f name) (c comment))
	      (ccl::external-call "_mus_sound_open_output" :address f :signed srate :signed chans :signed format :signed type :address c :signed)))

#+cmu (def-alien-routine ("mus_sound_reopen_output" mus-sound-reopen-output) c-call:int (arg c-call:c-string) (chans c-call:int) (format c-call:int) (type c-call:int) (data-loc c-call:int))
#+sbcl (sb-alien:define-alien-routine ("mus_sound_reopen_output" mus-sound-reopen-output) sb-alien:int (arg sb-alien:c-string) (chans sb-alien:int) (format sb-alien:int) (type sb-alien:int) (data-loc sb-alien:int))
#+allegro-v5.0 (ff:def-foreign-call (mus-sound-reopen-output "mus_sound_reopen_output")
				    ((arg (* :char) string) (chans :int) (format :int) (type :int) (data-loc :int)) :returning :int)
#+(or allegro-v6.0 allegro-v6.1 allegro-v6.2) (ff:def-foreign-call (mus-sound-reopen-output "mus_sound_reopen_output")
				    ((arg (* :char)) (chans :int) (format :int) (type :int) (data-loc :int)) :returning :int)
#+allegro-v7.0 (ff:def-foreign-call (mus-sound-reopen-output "mus_sound_reopen_output")
				    ((arg (* :char)) (chans :int) (format :int) (type :int) (data-loc :int)) :strings-convert t :returning :int)
#+openmcl (defun mus-sound-reopen-output (name chans format type loc)
	    (ccl:with-cstrs ((f name))
              (ccl::external-call "_mus_sound_reopen_output" :address f :signed chans :signed format :signed type (:signed 64) loc :signed)))

#+cmu (def-alien-routine ("mus_sound_close_input" mus-sound-close-input) c-call:int (fd c-call:int))
#+sbcl (sb-alien:define-alien-routine ("mus_sound_close_input" mus-sound-close-input) sb-alien:int (fd sb-alien:int))
#+allegro-v5.0 (ff:def-foreign-call (mus-sound-close-input "mus_sound_close_input") ((fd :int)) :returning :int)
#+(or allegro-v6.0 allegro-v6.1 allegro-v6.2) (ff:def-foreign-call (mus-sound-close-input "mus_sound_close_input") ((fd :int)) :returning :int)
#+allegro-v7.0 (ff:def-foreign-call (mus-sound-close-input "mus_sound_close_input") ((fd :int)) :strings-convert t :returning :int)
#+openmcl (defun mus-sound-close-input (fd) (ccl::external-call "_mus_sound_close_input" :signed fd :signed))

#+cmu (def-alien-routine ("mus_sound_close_output" mus-sound-close-output) c-call:int (fd c-call:int) (bytes-of-data c-call:int))
#+sbcl (sb-alien:define-alien-routine ("mus_sound_close_output" mus-sound-close-output) sb-alien:int (fd sb-alien:int) (bytes-of-data sb-alien:int))
#+allegro-v5.0 (ff:def-foreign-call (mus-sound-close-output "mus_sound_close_output") ((fd :int) (bytes-of-data :int)) :returning :int)
#+(or allegro-v6.0 allegro-v6.1 allegro-v6.2) (ff:def-foreign-call (mus-sound-close-output "mus_sound_close_output") ((fd :int) (bytes-of-data :int)) :returning :int)
#+allegro-v7.0 (ff:def-foreign-call (mus-sound-close-output "mus_sound_close_output") ((fd :int) (bytes-of-data :int)) :strings-convert t :returning :int)
#+openmcl (defun mus-sound-close-output (fd bytes) (ccl::external-call "_mus_sound_close_output" :signed fd (:signed 64) bytes :signed))

#+cmu (def-alien-routine ("mus_sound_read" mus-sound-read) c-call:int (fd c-call:int) (beg c-call:int) (end c-call:int) (chans c-call:int) (bufs (* float)))
#+sbcl (sb-alien:define-alien-routine ("mus_sound_read" mus-sound-read) sb-alien:int (fd sb-alien:int) (beg sb-alien:int) (end sb-alien:int) (chans sb-alien:int) (bufs (* float)))
#+allegro-v5.0 (ff:def-foreign-call (mus-sound-read "mus_sound_read") ((fd :int) (beg :int) (end :int) (chans :int) (bufs (* :float) array)) :returning :int)
#+(or allegro-v6.0 allegro-v6.1 allegro-v6.2) (ff:def-foreign-call (mus-sound-read "mus_sound_read") ((fd :int) (beg :int) (end :int) (chans :int) (bufs (* :float) array)) :returning :int)
#+allegro-v7.0 (ff:def-foreign-call (mus-sound-read "mus_sound_read") ((fd :int) (beg :int) (end :int) (chans :int) (bufs (* :float) array)) :strings-convert t :returning :int)
#+openmcl (defun mus-sound-read (fd beg end chans bufs)
	    (ccl::external-call "_mus_sound_read" :signed fd :signed beg :signed end :signed chans :address (heap-int* bufs) :signed))

#+cmu (def-alien-routine ("mus_sound_write" mus-sound-write) c-call:int (tfd c-call:int) (beg c-call:int) (end c-call:int) (chans c-call:int) (bufs (* float)))
#+sbcl (sb-alien:define-alien-routine ("mus_sound_write" mus-sound-write) sb-alien:int (tfd sb-alien:int) (beg sb-alien:int) (end sb-alien:int) (chans sb-alien:int) (bufs (* float)))
#+allegro-v5.0 (ff:def-foreign-call (mus-sound-write "mus_sound_write") ((tfd :int) (beg :int) (end :int) (chans :int) (bufs (* :float) array)) :returning :int)
#+(or allegro-v6.0 allegro-v6.1 allegro-v6.2) (ff:def-foreign-call (mus-sound-write "mus_sound_write") ((tfd :int) (beg :int) (end :int) (chans :int) (bufs (* :float) array)) :returning :int)
#+allegro-v7.0 (ff:def-foreign-call (mus-sound-write "mus_sound_write") ((tfd :int) (beg :int) (end :int) (chans :int) (bufs (* :float) array)) :strings-convert t :returning :int)
#+openmcl (defun mus-sound-write (fd beg end chans bufs)
	    (ccl::external-call "_mus_sound_write" :signed fd :signed beg :signed end :signed chans :address (heap-int* bufs) :signed))

#+cmu (def-alien-routine ("mus_sound_seek_frame" mus-sound-seek-frame) c-call:int (tfd c-call:int) (frame c-call:int))
#+sbcl (sb-alien:define-alien-routine ("mus_sound_seek_frame" mus-sound-seek-frame) sb-alien:int (tfd sb-alien:int) (frame sb-alien:int))
#+allegro-v5.0 (ff:def-foreign-call (mus-sound-seek-frame "mus_sound_seek_frame") ((tfd :int) (frame :int)) :returning :int)
#+(or allegro-v6.0 allegro-v6.1 allegro-v6.2) (ff:def-foreign-call (mus-sound-seek-frame "mus_sound_seek_frame") ((tfd :int) (frame :int)) :returning :int)
#+allegro-v7.0 (ff:def-foreign-call (mus-sound-seek-frame "mus_sound_seek_frame") ((tfd :int) (frame :int)) :strings-convert t :returning :int)
#+openmcl (defun mus-sound-seek-frame (fd frame) (ccl::external-call "_mus_sound_seek_frame" :signed fd (:signed 64) frame (:signed 64)))  

#+cmu (def-alien-routine ("mus_audio_describe" mus-audio-describe) c-call:void )
#+sbcl (sb-alien:define-alien-routine ("mus_audio_describe" mus-audio-describe) sb-alien:void )
#+allegro-v5.0 (ff:def-foreign-call (mus-audio-describe "mus_audio_describe") (:void) :returning :void)
#+(or allegro-v6.0 allegro-v6.1 allegro-v6.2) (ff:def-foreign-call (mus-audio-describe "mus_audio_describe") (:void) :returning :void)
#+allegro-v7.0 (ff:def-foreign-call (mus-audio-describe "mus_audio_describe") (:void) :strings-convert t :returning :void)
#+openmcl (defun mus-audio-describe () (ccl::external-call "_mus_audio_describe" :void))

#+cmu (def-alien-routine ("mus_audio_report" mus-audio-report) c-call:c-string )
#+sbcl (sb-alien:define-alien-routine ("mus_audio_report" mus-audio-report) sb-alien:c-string )
#+allegro-v5.0 (ff:def-foreign-call (mus-audio-report-1 "mus_audio_report") (:void) :returning :int)
#+allegro-v5.0 (defun mus-audio-report () (let ((ptr (mus-audio-report-1))) (ff:char*-to-string ptr)))
#+(or allegro-v6.0 allegro-v6.1 allegro-v6.2) (ff:def-foreign-call (mus-audio-report "mus_audio_report") (:void) :returning ((* :char)))
#+allegro-v7.0 (ff:def-foreign-call (mus-audio-report "mus_audio_report") (:void) :strings-convert t :returning ((* :char)))
#+openmcl (defun mus-audio-report () (get-cstring (ccl::external-call "_mus_audio_report" :address)))

#+cmu (def-alien-routine ("mus_audio_open_output" mus-audio-open-output) c-call:int (dev c-call:int) (srate c-call:int) (chans c-call:int) (format c-call:int) (size c-call:int))
#+sbcl (sb-alien:define-alien-routine ("mus_audio_open_output" mus-audio-open-output) sb-alien:int (dev sb-alien:int) (srate sb-alien:int) (chans sb-alien:int) (format sb-alien:int) (size sb-alien:int))
#+allegro-v5.0 (ff:def-foreign-call (mus-audio-open-output "mus_audio_open_output")
				    ((dev :int) (srate :int) (chans :int) (format :int) (size :int)) :returning :int)
#+(or allegro-v6.0 allegro-v6.1 allegro-v6.2) (ff:def-foreign-call (mus-audio-open-output "mus_audio_open_output")
				    ((dev :int) (srate :int) (chans :int) (format :int) (size :int)) :returning :int)
#+allegro-v7.0 (ff:def-foreign-call (mus-audio-open-output "mus_audio_open_output")
				    ((dev :int) (srate :int) (chans :int) (format :int) (size :int)) :strings-convert t :returning :int)
#+openmcl (defun mus-audio-open-output (dev sr chns frm siz)
	    (ccl::external-call "_mus_audio_open_output" :signed dev :signed sr :signed chns :signed frm :signed siz :signed))

#+cmu (def-alien-routine ("mus_audio_open_input" mus-audio-open-input) c-call:int (dev c-call:int) (srate c-call:int) (chans c-call:int) (format c-call:int) (size c-call:int))
#+sbcl (sb-alien:define-alien-routine ("mus_audio_open_input" mus-audio-open-input) sb-alien:int (dev sb-alien:int) (srate sb-alien:int) (chans sb-alien:int) (format sb-alien:int) (size sb-alien:int))
#+allegro-v5.0 (ff:def-foreign-call (mus-audio-open-input "mus_audio_open_input")
				    ((dev :int) (srate :int) (chans :int) (format :int) (size :int)) :returning :int)
#+(or allegro-v6.0 allegro-v6.1 allegro-v6.2) (ff:def-foreign-call (mus-audio-open-input "mus_audio_open_input")
				    ((dev :int) (srate :int) (chans :int) (format :int) (size :int)) :returning :int)
#+allegro-v7.0 (ff:def-foreign-call (mus-audio-open-input "mus_audio_open_input")
				    ((dev :int) (srate :int) (chans :int) (format :int) (size :int)) :strings-convert t :returning :int)
#+openmcl (defun mus-audio-open-input (dev sr chns frm siz)
	    (ccl::external-call "_mus_audio_open_input" :signed dev :signed sr :signed chns :signed frm :signed siz :signed))

#+cmu (def-alien-routine ("mus_audio_write" mus-audio-write) c-call:int (line c-call:int) (buf c-call:c-string) (bytes c-call:int))
#+sbcl (sb-alien:define-alien-routine ("mus_audio_write" mus-audio-write) sb-alien:int (line sb-alien:int) (buf sb-alien:c-string) (bytes sb-alien:int))
#+allegro-v5.0 (ff:def-foreign-call (mus-audio-write "mus_audio_write") ((line :int) (buf (* :char) string) (bytes :int)) :returning :int)
#+(or allegro-v6.0 allegro-v6.1 allegro-v6.2) (ff:def-foreign-call (mus-audio-write "mus_audio_write") ((line :int) (buf (* :char)) (bytes :int)) :returning :int)
#+allegro-v7.0 (ff:def-foreign-call (mus-audio-write "mus_audio_write") ((line :int) (buf (* :char)) (bytes :int)) :strings-convert t :returning :int)
#+openmcl (defun mus-audio-write (line buf bytes) (ccl::external-call "_mus_audio_write" :signed line :address (heap-int* buf) :signed bytes :signed))

#+cmu (def-alien-routine ("mus_audio_close" mus-audio-close) c-call:int (line c-call:int))
#+sbcl (sb-alien:define-alien-routine ("mus_audio_close" mus-audio-close) sb-alien:int (line sb-alien:int))
#+allegro-v5.0 (ff:def-foreign-call (mus-audio-close "mus_audio_close") ((line :int)) :returning :int)
#+(or allegro-v6.0 allegro-v6.1 allegro-v6.2) (ff:def-foreign-call (mus-audio-close "mus_audio_close") ((line :int)) :returning :int)
#+allegro-v7.0 (ff:def-foreign-call (mus-audio-close "mus_audio_close") ((line :int)) :strings-convert t :returning :int)
#+openmcl (defun mus-audio-close (fd) (ccl::external-call "_mus_audio_close" :signed fd :signed))

#+cmu (def-alien-routine ("mus_audio_read" mus-audio-read) c-call:int (line c-call:int) (buf c-call:c-string) (bytes c-call:int))
#+sbcl (sb-alien:define-alien-routine ("mus_audio_read" mus-audio-read) sb-alien:int (line sb-alien:int) (buf sb-alien:c-string) (bytes sb-alien:int))
#+allegro-v5.0 (ff:def-foreign-call (mus-audio-read "mus_audio_read") ((line :int) (buf (* :char) string) (bytes :int)) :returning :int)
#+(or allegro-v6.0 allegro-v6.1 allegro-v6.2) (ff:def-foreign-call (mus-audio-read "mus_audio_read") ((line :int) (buf (* :char)) (bytes :int)) :returning :int)
#+allegro-v7.0 (ff:def-foreign-call (mus-audio-read "mus_audio_read") ((line :int) (buf (* :char)) (bytes :int)) :strings-convert t :returning :int)
#+openmcl (defun mus-audio-read (line buf bytes) (ccl::external-call "_mus_audio_read" :signed line :address (heap-int* buf) :signed bytes :signed))

#+cmu (def-alien-routine ("mus_audio_mixer_read" mus-audio-mixer-read) c-call:int (dev c-call:int) (field c-call:int) (chan c-call:int) (val (* float)))
#+sbcl (sb-alien:define-alien-routine ("mus_audio_mixer_read" mus-audio-mixer-read) sb-alien:int (dev sb-alien:int) (field sb-alien:int) (chan sb-alien:int) (val (* float)))
#+allegro-v5.0 (ff:def-foreign-call (mus-audio-mixer-read "mus_audio_mixer_read")
				    ((dev :int) (field :int) (chan :int) (val (* :float) array)) :returning :int)
#+(or allegro-v6.0 allegro-v6.1 allegro-v6.2) (ff:def-foreign-call (mus-audio-mixer-read "mus_audio_mixer_read")
				    ((dev :int) (field :int) (chan :int) (val (* :float) array)) :returning :int)
#+allegro-v7.0 (ff:def-foreign-call (mus-audio-mixer-read "mus_audio_mixer_read")
				    ((dev :int) (field :int) (chan :int) (val (* :float) array)) :strings-convert t :returning :int)
#+openmcl (defun mus-audio-mixer-read (dev field chan val)
	    (ccl::external-call "_mus_audio_mixer_read" :signed dev :signed field :signed chan :address (heap-float* val) :signed))

#+cmu (def-alien-routine ("mus_audio_mixer_write" mus-audio-mixer-write) c-call:int (dev c-call:int) (field c-call:int) (chan c-call:int) (val (* float)))
#+sbcl (sb-alien:define-alien-routine ("mus_audio_mixer_write" mus-audio-mixer-write) sb-alien:int (dev sb-alien:int) (field sb-alien:int) (chan sb-alien:int) (val (* float)))
#+allegro-v5.0 (ff:def-foreign-call (mus-audio-mixer-write "mus_audio_mixer_write")
				    ((dev :int) (field :int) (chan :int) (val (* :float) array)) :returning :int)
#+(or allegro-v6.0 allegro-v6.1 allegro-v6.2) (ff:def-foreign-call (mus-audio-mixer-write "mus_audio_mixer_write")
				    ((dev :int) (field :int) (chan :int) (val (* :float) array)) :returning :int)
#+allegro-v7.0 (ff:def-foreign-call (mus-audio-mixer-write "mus_audio_mixer_write")
				    ((dev :int) (field :int) (chan :int) (val (* :float) array)) :strings-convert t :returning :int)
#+openmcl (defun mus-audio-mixer-write (dev field chan val)
	    (ccl::external-call "_mus_audio_mixer_write" :signed dev :signed field :signed chan :address (heap-float* val) :signed))

#+cmu (def-alien-routine ("mus_audio_initialize" mus-audio-initialize) c-call:int )
#+sbcl (sb-alien:define-alien-routine ("mus_audio_initialize" mus-audio-initialize) sb-alien:int )
#+allegro-v5.0 (ff:def-foreign-call (mus-audio-initialize "mus_audio_initialize") (:void) :returning :int)
#+(or allegro-v6.0 allegro-v6.1 allegro-v6.2) (ff:def-foreign-call (mus-audio-initialize "mus_audio_initialize") (:void) :returning :int)
#+allegro-v7.0 (ff:def-foreign-call (mus-audio-initialize "mus_audio_initialize") (:void) :strings-convert t :returning :int)
#+openmcl (defun mus-audio-initialize () (ccl::external-call "_mus_audio_initialize" :signed))

#+cmu (def-alien-routine ("mus_audio_systems" mus-audio-systems) c-call:int )
#+sbcl (sb-alien:define-alien-routine ("mus_audio_systems" mus-audio-systems) sb-alien:int )
#+allegro-v5.0 (ff:def-foreign-call (mus-audio-systems "mus_audio_systems") (:void) :returning :int)
#+(or allegro-v6.0 allegro-v6.1 allegro-v6.2) (ff:def-foreign-call (mus-audio-systems "mus_audio_systems") (:void) :returning :int)
#+allegro-v7.0 (ff:def-foreign-call (mus-audio-systems "mus_audio_systems") (:void) :strings-convert t :returning :int)
#+openmcl (defun mus-audio-systems () (ccl::external-call "_mus_audio_systems" :signed))

#+cmu (def-alien-routine ("mus_audio_system_name" mus-audio-system-name) c-call:c-string (system c-call:int))
#+sbcl (sb-alien:define-alien-routine ("mus_audio_system_name" mus-audio-system-name) sb-alien:c-string (system sb-alien:int))
#+allegro-v5.0 (ff:def-foreign-call (mus-audio-system-name-1 "mus_audio_system_name") ((system :int)) :returning :int)
#+allegro-v5.0 (defun mus-audio-system-name (name) (let ((ptr (mus-audio-system-name-1 name))) (ff:char*-to-string ptr)))
#+(or allegro-v6.0 allegro-v6.1 allegro-v6.2) (ff:def-foreign-call (mus-audio-system-name "mus_audio_system_name") ((system :int)) :returning ((* :char)))
#+allegro-v7.0 (ff:def-foreign-call (mus-audio-system-name "mus_audio_system_name") ((system :int)) :strings-convert t :returning ((* :char)))
#+openmcl (defun mus-audio-system-name (sys) (get-cstring (ccl::external-call "_mus_audio_system_name" :signed sys :address)))

#+cmu (def-alien-routine ("mus_audio_moniker" mus-audio-moniker) c-call:c-string )
#+sbcl (sb-alien:define-alien-routine ("mus_audio_moniker" mus-audio-moniker) sb-alien:c-string )
#+allegro-v5.0 (ff:def-foreign-call (mus-audio-moniker-1 "mus_audio_moniker") (:void) :returning :int)
#+allegro-v5.0 (defun mus-audio-moniker () (let ((ptr (mus-audio-moniker-1))) (ff:char*-to-string ptr)))
#+(or allegro-v6.0 allegro-v6.1 allegro-v6.2) (ff:def-foreign-call (mus-audio-moniker "mus_audio_moniker") (:void) :returning ((* :char)))
#+allegro-v7.0 (ff:def-foreign-call (mus-audio-moniker "mus_audio_moniker") (:void) :strings-convert t :returning ((* :char)))
#+openmcl (defun mus-audio-moniker () (get-cstring (ccl::external-call "_mus_audio_moniker" :address)))

#+cmu (def-alien-routine ("mus_file_open_read" mus-file-open-read) c-call:int (arg c-call:c-string))
#+sbcl (sb-alien:define-alien-routine ("mus_file_open_read" mus-file-open-read) sb-alien:int (arg sb-alien:c-string))
#+allegro-v5.0 (ff:def-foreign-call (mus-file-open-read "mus_file_open_read") ((arg (* :char) string)) :returning :int)
#+(or allegro-v6.0 allegro-v6.1 allegro-v6.2) (ff:def-foreign-call (mus-file-open-read "mus_file_open_read") ((arg (* :char))) :returning :int)
#+allegro-v7.0 (ff:def-foreign-call (mus-file-open-read "mus_file_open_read") ((arg (* :char))) :strings-convert t :returning :int)
#+openmcl (defun mus-file-open-read (file) (ccl:with-cstrs ((f file)) (ccl::external-call "_mus_file_open_read" :address f :signed)))

#+cmu (def-alien-routine ("mus_file_probe" mus-file-probe) c-call:int (arg c-call:c-string))
#+sbcl (sb-alien:define-alien-routine ("mus_file_probe" mus-file-probe) sb-alien:int (arg sb-alien:c-string))
#+allegro-v5.0 (ff:def-foreign-call (mus-file-probe "mus_file_probe") ((arg (* :char) string)) :returning :int)
#+(or allegro-v6.0 allegro-v6.1 allegro-v6.2) (ff:def-foreign-call (mus-file-probe "mus_file_probe") ((arg (* :char))) :returning :int)
#+allegro-v7.0 (ff:def-foreign-call (mus-file-probe "mus_file_probe") ((arg (* :char))) :strings-convert t :returning :int)
#+openmcl (defun mus-file-probe (file) (ccl:with-cstrs ((f file)) (ccl::external-call "_mus_file_probe" :address f :signed)))

#+cmu (def-alien-routine ("mus_file_open_write" mus-file-open-write) c-call:int (arg c-call:c-string))
#+sbcl (sb-alien:define-alien-routine ("mus_file_open_write" mus-file-open-write) sb-alien:int (arg sb-alien:c-string))
#+allegro-v5.0 (ff:def-foreign-call (mus-file-open-write "mus_file_open_write") ((arg (* :char) string)) :returning :int)
#+(or allegro-v6.0 allegro-v6.1 allegro-v6.2) (ff:def-foreign-call (mus-file-open-write "mus_file_open_write") ((arg (* :char))) :returning :int)
#+allegro-v7.0 (ff:def-foreign-call (mus-file-open-write "mus_file_open_write") ((arg (* :char))) :strings-convert t :returning :int)
#+openmcl (defun mus-file-open-write (file) (ccl:with-cstrs ((f file)) (ccl::external-call "_mus_file_open_write" :address f :signed)))

#+cmu (def-alien-routine ("mus_file_create" mus-file-create) c-call:int (arg c-call:c-string))
#+sbcl (sb-alien:define-alien-routine ("mus_file_create" mus-file-create) sb-alien:int (arg sb-alien:c-string))
#+allegro-v5.0 (ff:def-foreign-call (mus-file-create "mus_file_create") ((arg (* :char) string)) :returning :int)
#+(or allegro-v6.0 allegro-v6.1 allegro-v6.2) (ff:def-foreign-call (mus-file-create "mus_file_create") ((arg (* :char))) :returning :int)
#+allegro-v7.0 (ff:def-foreign-call (mus-file-create "mus_file_create") ((arg (* :char))) :strings-convert t :returning :int)
#+openmcl (defun mus-file-create (file) (ccl:with-cstrs ((f file)) (ccl::external-call "_mus_file_create" :address f :signed)))

#+cmu (def-alien-routine ("mus_file_reopen_write" mus-file-reopen-write) c-call:int (arg c-call:c-string))
#+sbcl (sb-alien:define-alien-routine ("mus_file_reopen_write" mus-file-reopen-write) sb-alien:int (arg sb-alien:c-string))
#+allegro-v5.0 (ff:def-foreign-call (mus-file-reopen-write "mus_file_reopen_write") ((arg (* :char) string)) :returning :int)
#+(or allegro-v6.0 allegro-v6.1 allegro-v6.2) (ff:def-foreign-call (mus-file-reopen-write "mus_file_reopen_write") ((arg (* :char))) :returning :int)
#+allegro-v7.0 (ff:def-foreign-call (mus-file-reopen-write "mus_file_reopen_write") ((arg (* :char))) :strings-convert t :returning :int)
#+openmcl (defun mus-file-reopen-write (file) (ccl:with-cstrs ((f file)) (ccl::external-call "_mus_file_reopen_write" :address f :signed)))

#+cmu (def-alien-routine ("mus_file_close" mus-file-close) c-call:int (fd c-call:int))
#+sbcl (sb-alien:define-alien-routine ("mus_file_close" mus-file-close) sb-alien:int (fd sb-alien:int))
#+allegro-v5.0 (ff:def-foreign-call (mus-file-close "mus_file_close") ((fd :int)) :returning :int)
#+(or allegro-v6.0 allegro-v6.1 allegro-v6.2) (ff:def-foreign-call (mus-file-close "mus_file_close") ((fd :int)) :returning :int)
#+allegro-v7.0 (ff:def-foreign-call (mus-file-close "mus_file_close") ((fd :int)) :strings-convert t :returning :int)
#+openmcl (defun mus-file-close (fd) (ccl::external-call "_mus_file_close" :signed fd :signed))

#+cmu (def-alien-routine ("mus_file_seek_frame" mus-file-seek-frame) c-call:int (tfd c-call:int) (frame c-call:int))
#+sbcl (sb-alien:define-alien-routine ("mus_file_seek_frame" mus-file-seek-frame) sb-alien:int (tfd sb-alien:int) (frame sb-alien:int))
#+allegro-v5.0 (ff:def-foreign-call (mus-file-seek-frame "mus_file_seek_frame") ((tfd :int) (frame :int)) :returning :int)
#+(or allegro-v6.0 allegro-v6.1 allegro-v6.2) (ff:def-foreign-call (mus-file-seek-frame "mus_file_seek_frame") ((tfd :int) (frame :int)) :returning :int)
#+allegro-v7.0 (ff:def-foreign-call (mus-file-seek-frame "clm_file_seek_frame") ((tfd :int) (frame :int)) :strings-convert t :returning :int)
#+openmcl (defun mus-file-seek-frame (fd off) (ccl::external-call "_mus_file_seek_frame" :signed fd (:signed 64) off (:signed 64)))

#+cmu (def-alien-routine ("mus_file_read" mus-file-read) c-call:int (fd c-call:int) (beg c-call:int) (end c-call:int) (chans c-call:int) (bufs (* float)))
#+sbcl (sb-alien:define-alien-routine ("mus_file_read" mus-file-read) sb-alien:int (fd sb-alien:int) (beg sb-alien:int) (end sb-alien:int) (chans sb-alien:int) (bufs (* float)))
#+allegro-v5.0 (ff:def-foreign-call (mus-file-read "mus_file_read") ((fd :int) (beg :int) (end :int) (chans :int) (bufs (* :float) array)) :returning :int)
#+(or allegro-v6.0 allegro-v6.1 allegro-v6.2) (ff:def-foreign-call (mus-file-read "mus_file_read") ((fd :int) (beg :int) (end :int) (chans :int) (bufs (* :float) array)) :returning :int)
#+allegro-v7.0 (ff:def-foreign-call (mus-file-read "mus_file_read") ((fd :int) (beg :int) (end :int) (chans :int) (bufs (* :float) array)) :strings-convert t :returning :int)
#+openmcl (defun mus-file-read (fd beg end chans buf)
	    (ccl::external-call "_mus_file_read" :signed fd :signed beg :signed end :signed chans :address (heap-float* buf) :signed))

#+cmu (def-alien-routine ("mus_file_read_chans" mus-file-read-chans) c-call:int (fd c-call:int) (beg c-call:int) (end c-call:int) (chans c-call:int) (bufs (* float)) (cm (* float)))
#+sbcl (sb-alien:define-alien-routine ("mus_file_read_chans" mus-file-read-chans) sb-alien:int (fd sb-alien:int) (beg sb-alien:int) (end sb-alien:int) (chans sb-alien:int) (bufs (* float)) (cm (* float)))
#+allegro-v5.0 (ff:def-foreign-call (mus-file-read-chans "mus_file_read_chans")
				    ((fd :int) (beg :int) (end :int) (chans :int) (bufs (* :float) array) (cm (* :float) array)) :returning :int)
#+(or allegro-v6.0 allegro-v6.1 allegro-v6.2) (ff:def-foreign-call (mus-file-read-chans "mus_file_read_chans")
				    ((fd :int) (beg :int) (end :int) (chans :int) (bufs (* :float) array) (cm (* :float) array)) :returning :int)
#+allegro-v7.0 (ff:def-foreign-call (mus-file-read-chans "mus_file_read_chans")
				    ((fd :int) (beg :int) (end :int) (chans :int) (bufs (* :float) array) (cm (* :float) array)) :strings-convert t :returning :int)
#+openmcl (defun mus-file-read-chans (fd beg end chans buf cm)
	    (ccl::external-call "_mus_file_read_chans"
				:signed fd :signed beg :signed end :signed chans :address (heap-float* buf) :address (heap-float* cm)
				:signed))

#+cmu (def-alien-routine ("mus_file_write_zeros" mus-file-write-zeros) c-call:int (tfd c-call:int) (num c-call:int))
#+sbcl (sb-alien:define-alien-routine ("mus_file_write_zeros" mus-file-write-zeros) sb-alien:int (tfd sb-alien:int) (num sb-alien:int))
#+allegro-v5.0 (ff:def-foreign-call (mus-file-write-zeros "mus_file_write_zeros") ((tfd :int) (num :int)) :returning :int)
#+(or allegro-v6.0 allegro-v6.1 allegro-v6.2) (ff:def-foreign-call (mus-file-write-zeros "mus_file_write_zeros") ((tfd :int) (num :int)) :returning :int)
#+allegro-v7.0 (ff:def-foreign-call (mus-file-write-zeros "mus_file_write_zeros") ((tfd :int) (num :int)) :strings-convert t :returning :int)
#+openmcl (defun mus-file-write-zeros (fd num) (ccl::external-call "_mus_file_write_zeros" :signed fd :signed num :signed))

#+cmu (def-alien-routine ("mus_file_write" mus-file-write) c-call:int (tfd c-call:int) (beg c-call:int) (end c-call:int) (chans c-call:int) (bufs (* float)))
#+sbcl (sb-alien:define-alien-routine ("mus_file_write" mus-file-write) sb-alien:int (tfd sb-alien:int) (beg sb-alien:int) (end sb-alien:int) (chans sb-alien:int) (bufs (* float)))
#+allegro-v5.0 (ff:def-foreign-call (mus-file-write "mus_file_write")
				    ((tfd :int) (beg :int) (end :int) (chans :int) (bufs (* :float) array)) :returning :int)
#+(or allegro-v6.0 allegro-v6.1 allegro-v6.2) (ff:def-foreign-call (mus-file-write "mus_file_write")
				    ((tfd :int) (beg :int) (end :int) (chans :int) (bufs (* :float) array)) :returning :int)
#+allegro-v7.0 (ff:def-foreign-call (mus-file-write "mus_file_write")
				    ((tfd :int) (beg :int) (end :int) (chans :int) (bufs (* :float) array)) :strings-convert t :returning :int)
#+openmcl (defun mus-file-write (fd beg end chans buf)
	    (ccl::external-call "_mus_file_write" :signed fd :signed beg :signed end :signed chans :address (heap-float* buf) :signed))

#+cmu (def-alien-routine ("mus_file_read_any" mus-file-read-any) c-call:int (tfd c-call:int) (beg c-call:int) (chans c-call:int) (nints c-call:int) (bufs (* float)) (cm (* float)))
#+sbcl (sb-alien:define-alien-routine ("mus_file_read_any" mus-file-read-any) sb-alien:int (tfd sb-alien:int) (beg sb-alien:int) (chans sb-alien:int) (nints sb-alien:int) (bufs (* float)) (cm (* float)))
#+allegro-v5.0 (ff:def-foreign-call (mus-file-read-any "mus_file_read_any")
				    ((tfd :int) (beg :int) (chans :int) (nints :int) (bufs (* :float) array) (cm (* :float) array)) :returning :int)
#+(or allegro-v6.0 allegro-v6.1 allegro-v6.2) (ff:def-foreign-call (mus-file-read-any "mus_file_read_any")
				    ((tfd :int) (beg :int) (chans :int) (nints :int) (bufs (* :float) array) (cm (* :float) array)) :returning :int)
#+allegro-v7.0 (ff:def-foreign-call (mus-file-read-any "mus_file_read_any")
				    ((tfd :int) (beg :int) (chans :int) (nints :int) (bufs (* :float) array) (cm (* :float) array)) :strings-convert t :returning :int)
#+openmcl (defun mus-file-read-any (fd beg chans num buf cm)
	    (ccl::external-call "_mus_file_read_any"
				:signed fd :signed beg :signed chans :signed num :address (heap-float* buf) :address (heap-float* cm)
				:signed))

#+cmu (def-alien-routine ("mus_file_read_file" mus-file-read-file) c-call:int (tfd c-call:int) (beg c-call:int) (chans c-call:int) (nints c-call:int) (bufs (* float)))
#+sbcl (sb-alien:define-alien-routine ("mus_file_read_file" mus-file-read-file) sb-alien:int (tfd sb-alien:int) (beg sb-alien:int) (chans sb-alien:int) (nints sb-alien:int) (bufs (* float)))
#+allegro-v5.0 (ff:def-foreign-call (mus-file-read-file "mus_file_read_file")
				    ((tfd :int) (beg :int) (chans :int) (nints :int) (bufs (* :float) array)) :returning :int)
#+(or allegro-v6.0 allegro-v6.1 allegro-v6.2) (ff:def-foreign-call (mus-file-read-file "mus_file_read_file")
				    ((tfd :int) (beg :int) (chans :int) (nints :int) (bufs (* :float) array)) :returning :int)
#+allegro-v7.0 (ff:def-foreign-call (mus-file-read-file "mus_file_read_file")
				    ((tfd :int) (beg :int) (chans :int) (nints :int) (bufs (* :float) array)) :strings-convert t :returning :int)
#+openmcl (defun mus-file-read-file (fd beg chans num buf)
	    (ccl::external-call "_mus_file_read_file"
				:signed fd :signed beg :signed chans :signed num :address (heap-float* buf)
				:signed))

#+cmu (def-alien-routine ("mus_file_read_buffer" mus-file-read-buffer) c-call:int (charbuf-data-format c-call:int) (beg c-call:int) (chans c-call:int) (nints c-call:int) (bufs (* float)) (charbuf c-call:c-string))
#+sbcl (sb-alien:define-alien-routine ("mus_file_read_buffer" mus-file-read-buffer) sb-alien:int (charbuf-data-format sb-alien:int) (beg sb-alien:int) (chans sb-alien:int) (nints sb-alien:int) (bufs (* float)) (charbuf sb-alien:c-string))
#+allegro-v5.0 (ff:def-foreign-call (mus-file-read-buffer "mus_file_read_buffer")
				    ((charbuf-data-format :int) (beg :int) (chans :int) (nints :int) (bufs (* :float) array) (charbuf (* :char) string))
				    :returning :int)
#+(or allegro-v6.0 allegro-v6.1 allegro-v6.2) (ff:def-foreign-call (mus-file-read-buffer "mus_file_read_buffer")
				    ((charbuf-data-format :int) (beg :int) (chans :int) (nints :int) (bufs (* :float) array) (charbuf (* :char)))
				    :returning :int)
#+allegro-v7.0 (ff:def-foreign-call (mus-file-read-buffer "mus_file_read_buffer")
				    ((charbuf-data-format :int) (beg :int) (chans :int) (nints :int) (bufs (* :float) array) (charbuf (* :char)))
				    :strings-convert t :returning :int)
#+openmcl (defun mus-file-read-buffer (format beg chans num buf chars)
	    (ccl::external-call "_mus_file_read_buffer"
				:signed format :signed beg :signed chans :signed num :address (heap-float* buf) :address (heap-int* chars)
				:signed))

#+cmu (def-alien-routine ("mus_file_write_file" mus-file-write-file) c-call:int (tfd c-call:int) (beg c-call:int) (end c-call:int) (chans c-call:int) (bufs (* float)))
#+sbcl (sb-alien:define-alien-routine ("mus_file_write_file" mus-file-write-file) sb-alien:int (tfd sb-alien:int) (beg sb-alien:int) (end sb-alien:int) (chans sb-alien:int) (bufs (* float)))
#+allegro-v5.0 (ff:def-foreign-call (mus-file-write-file "mus_file_write_file")
				    ((tfd :int) (beg :int) (end :int) (chans :int) (bufs (* :float) array)) :returning :int)
#+(or allegro-v6.0 allegro-v6.1 allegro-v6.2) (ff:def-foreign-call (mus-file-write-file "mus_file_write_file")
				    ((tfd :int) (beg :int) (end :int) (chans :int) (bufs (* :float) array)) :returning :int)
#+allegro-v7.0 (ff:def-foreign-call (mus-file-write-file "mus_file_write_file")
				    ((tfd :int) (beg :int) (end :int) (chans :int) (bufs (* :float) array)) :strings-convert t :returning :int)
#+openmcl (defun mus-file-write (fd beg end chans buf)
	    (ccl::external-call "_mus_file_write_buffer"
				:signed fd :signed beg :signed end :signed chans :address (heap-float* buf)
				:signed))

#+cmu (def-alien-routine ("mus_file_write_buffer" mus-file-write-buffer) c-call:int (charbuf-data-format c-call:int) (beg c-call:int) (end c-call:int) (chans c-call:int) (bufs (* float)) (charbuf c-call:c-string) (clipped c-call:int))
#+sbcl (sb-alien:define-alien-routine ("mus_file_write_buffer" mus-file-write-buffer) sb-alien:int (charbuf-data-format sb-alien:int) (beg sb-alien:int) (end sb-alien:int) (chans sb-alien:int) (bufs (* float)) (charbuf sb-alien:c-string) (clipped sb-alien:int))
#+allegro-v5.0 (ff:def-foreign-call (mus-file-write-buffer "mus_file_write_buffer")
				    ((charbuf-data-format :int) (beg :int) (end :int) (chans :int) (bufs (* :float) array)
				     (charbuf (* :char) string) (clipped :int))
				    :returning :int)
#+(or allegro-v6.0 allegro-v6.1 allegro-v6.2) (ff:def-foreign-call (mus-file-write-buffer "mus_file_write_buffer")
				    ((charbuf-data-format :int) (beg :int) (end :int) (chans :int) (bufs (* :float) array)
				     (charbuf (* :char)) (clipped :int))
				    :returning :int)
#+allegro-v7.0 (ff:def-foreign-call (mus-file-write-buffer "mus_file_write_buffer")
				    ((charbuf-data-format :int) (beg :int) (end :int) (chans :int) (bufs (* :float) array)
				     (charbuf (* :char)) (clipped :int))
				    :strings-convert t :returning :int)
#+openmcl (defun mus-file-write-buffer (format beg end chans buf chars clipped)
	    (ccl::external-call "_mus_file_write_buffer"
				:signed format :signed beg :signed end :signed chans :address (heap-float* buf) :address (heap-int* chars) :signed clipped
				:signed))

#+cmu (def-alien-routine ("mus_file_set_data_clipped" mus-file-set-data-clipped) c-call:int (tfd c-call:int) (clipped c-call:int))
#+sbcl (sb-alien:define-alien-routine ("mus_file_set_data_clipped" mus-file-set-data-clipped) sb-alien:int (tfd sb-alien:int) (clipped sb-alien:int))
#+allegro-v5.0 (ff:def-foreign-call (mus-file-set-data-clipped "mus_file_set_data_clipped") ((tfd :int) (clipped :int)) :returning :int)
#+(or allegro-v6.0 allegro-v6.1 allegro-v6.2) (ff:def-foreign-call (mus-file-set-data-clipped "mus_file_set_data_clipped") ((tfd :int) (clipped :int)) :returning :int)
#+allegro-v7.0 (ff:def-foreign-call (mus-file-set-data-clipped "mus_file_set_data_clipped") ((tfd :int) (clipped :int)) :strings-convert t :returning :int)
#+openmcl (defun mus-file-set-data-clipped (fd on) (ccl::external-call "_mus_file_set_data_clipped" :signed fd :signed on :signed))

#+cmu (def-alien-routine ("mus_file_set_header_type" mus-file-set-header-type) c-call:int (tfd c-call:int) (type c-call:int))
#+sbcl (sb-alien:define-alien-routine ("mus_file_set_header_type" mus-file-set-header-type) sb-alien:int (tfd sb-alien:int) (type sb-alien:int))
#+allegro-v5.0 (ff:def-foreign-call (mus-file-set-header-type "mus_file_set_header_type") ((tfd :int) (type :int)) :returning :int)
#+(or allegro-v6.0 allegro-v6.1 allegro-v6.2) (ff:def-foreign-call (mus-file-set-header-type "mus_file_set_header_type") ((tfd :int) (type :int)) :returning :int)
#+allegro-v7.0 (ff:def-foreign-call (mus-file-set-header-type "mus_file_set_header_type") ((tfd :int) (type :int)) :strings-convert t :returning :int)
#+openmcl (defun mus-file-set-header-type (fd on) (ccl::external-call "_mus_file_set_header_type" :signed fd :signed on :signed))

#+cmu (def-alien-routine ("mus_file_header_type" mus-file-header-type) c-call:int (tfd c-call:int))
#+sbcl (sb-alien:define-alien-routine ("mus_file_header_type" mus-file-header-type) sb-alien:int (tfd sb-alien:int))
#+allegro-v5.0 (ff:def-foreign-call (mus-file-header-type "mus_file_header_type") ((tfd :int)) :returning :int)
#+(or allegro-v6.0 allegro-v6.1 allegro-v6.2) (ff:def-foreign-call (mus-file-header-type "mus_file_header_type") ((tfd :int)) :returning :int)
#+allegro-v7.0 (ff:def-foreign-call (mus-file-header-type "mus_file_header_type") ((tfd :int)) :strings-convert t :returning :int)
#+openmcl (defun mus-file-header_type (fd) (ccl::external-call "_mus_file_header_type" :signed fd :signed))

#+cmu (def-alien-routine ("mus_file_fd_name" mus-file-fd-name) c-call:c-string (tfd c-call:int))
#+sbcl (sb-alien:define-alien-routine ("mus_file_fd_name" mus-file-fd-name) sb-alien:c-string (tfd sb-alien:int))
#+allegro-v5.0 (ff:def-foreign-call (mus-file-fd-name-1 "mus_file_fd_name") ((tfd :int)) :returning :int)
#+allegro-v5.0 (defun mus-file-fd-name (name) (let ((ptr (mus-file-fd-name-1 name))) (ff:char*-to-string ptr)))
#+(or allegro-v6.0 allegro-v6.1 allegro-v6.2) (ff:def-foreign-call (mus-file-fd-name "mus_file_fd_name") ((tfd :int)) :returning ((* :char)))
#+allegro-v7.0 (ff:def-foreign-call (mus-file-fd-name "mus_file_fd_name") ((tfd :int)) :strings-convert t :returning ((* :char)))
#+openmcl (defun mus-file-fd-name (fd) (get-cstring (ccl::external-call "_mus_file_fd_name" :signed fd :address)))

#+cmu (def-alien-routine ("mus_file_set_chans" mus-file-set-chans) c-call:int (tfd c-call:int) (chans c-call:int))
#+sbcl (sb-alien:define-alien-routine ("mus_file_set_chans" mus-file-set-chans) sb-alien:int (tfd sb-alien:int) (chans sb-alien:int))
#+allegro-v5.0 (ff:def-foreign-call (mus-file-set-chans "mus_file_set_chans") ((tfd :int) (chans :int)) :returning :int)
#+(or allegro-v6.0 allegro-v6.1 allegro-v6.2) (ff:def-foreign-call (mus-file-set-chans "mus_file_set_chans") ((tfd :int) (chans :int)) :returning :int)
#+allegro-v7.0 (ff:def-foreign-call (mus-file-set-chans "mus_file_set_chans") ((tfd :int) (chans :int)) :strings-convert t :returning :int)
#+openmcl (defun mus-file-set-chans (fd on) (ccl::external-call "_mus_file_set_chans" :signed fd :signed on :signed))

#+cmu (def-alien-routine ("mus_file_prescaler" mus-file-prescaler) double-float (tfd c-call:int))
#+sbcl (sb-alien:define-alien-routine ("mus_file_prescaler" mus-file-prescaler) double-float (tfd sb-alien:int))
#+allegro-v5.0 (ff:def-foreign-call (mus-file-prescaler "mus_file_prescaler") ((tfd :int)) :returning :float)
#+(or allegro-v6.0 allegro-v6.1 allegro-v6.2) (ff:def-foreign-call (mus-file-prescaler "mus_file_prescaler") ((tfd :int)) :returning :float)
#+allegro-v7.0 (ff:def-foreign-call (mus-file-prescaler "mus_file_prescaler") ((tfd :int)) :strings-convert t :returning :float)
#+openmcl (defun mus-file-prescaler (fd) (ccl::external-call "_mus_file_prescaler" :signed fd :single-float))

#+cmu (def-alien-routine ("mus_file_set_prescaler" mus-file-set-prescaler) double-float (tfd c-call:int) (val double-float))
#+sbcl (sb-alien:define-alien-routine ("mus_file_set_prescaler" mus-file-set-prescaler) double-float (tfd sb-alien:int) (val double-float))
#+allegro-v5.0 (ff:def-foreign-call (mus-file-set-prescaler "mus_file_set_prescaler") ((tfd :int) (val :float)) :returning :float)
#+(or allegro-v6.0 allegro-v6.1 allegro-v6.2) (ff:def-foreign-call (mus-file-set-prescaler "mus_file_set_prescaler") ((tfd :int) (val :float)) :returning :float)
#+allegro-v7.0 (ff:def-foreign-call (mus-file-set-prescaler "mus_file_set_prescaler") ((tfd :int) (val :float)) :strings-convert t :returning :float)
#+openmcl (defun mus-file-set-prescaler (fd val) (ccl::external-call "_mus_file_set_prescaler" :signed fd :single-float val :single-float))

#+cmu (def-alien-routine ("mus_header_samples" mus-header-samples) c-call:int )
#+sbcl (sb-alien:define-alien-routine ("mus_header_samples" mus-header-samples) sb-alien:int )
#+allegro-v5.0 (ff:def-foreign-call (mus-header-samples "mus_header_samples") (:void) :returning :int)
#+(or allegro-v6.0 allegro-v6.1 allegro-v6.2) (ff:def-foreign-call (mus-header-samples "mus_header_samples") (:void) :returning :int)
#+allegro-v7.0 (ff:def-foreign-call (mus-header-samples "clm_header_samples") (:void) :strings-convert t :returning :int)
#+openmcl (defun mus-header-samples () (ccl::external-call "_mus_header_samples" (:signed 64)))

#+cmu (def-alien-routine ("mus_header_data_location" mus-header-data-location) c-call:int )
#+sbcl (sb-alien:define-alien-routine ("mus_header_data_location" mus-header-data-location) sb-alien:int )
#+allegro-v5.0 (ff:def-foreign-call (mus-header-data-location "mus_header_data_location") (:void) :returning :int)
#+(or allegro-v6.0 allegro-v6.1 allegro-v6.2) (ff:def-foreign-call (mus-header-data-location "mus_header_data_location") (:void) :returning :int)
#+allegro-v7.0 (ff:def-foreign-call (mus-header-data-location "clm_header_data_location") (:void) :strings-convert t :returning :int)
#+openmcl (defun mus-header-data-location () (ccl::external-call "_mus_header_data_location" (:signed 64)))

#+cmu (def-alien-routine ("mus_header_chans" mus-header-chans) c-call:int )
#+sbcl (sb-alien:define-alien-routine ("mus_header_chans" mus-header-chans) sb-alien:int )
#+allegro-v5.0 (ff:def-foreign-call (mus-header-chans "mus_header_chans") (:void) :returning :int)
#+(or allegro-v6.0 allegro-v6.1 allegro-v6.2) (ff:def-foreign-call (mus-header-chans "mus_header_chans") (:void) :returning :int)
#+allegro-v7.0 (ff:def-foreign-call (mus-header-chans "mus_header_chans") (:void) :strings-convert t :returning :int)
#+openmcl (defun mus-header-chans () (ccl::external-call "_mus_header_chans" :signed))

#+cmu (def-alien-routine ("mus_header_srate" mus-header-srate) c-call:int )
#+sbcl (sb-alien:define-alien-routine ("mus_header_srate" mus-header-srate) sb-alien:int )
#+allegro-v5.0 (ff:def-foreign-call (mus-header-srate "mus_header_srate") (:void) :returning :int)
#+(or allegro-v6.0 allegro-v6.1 allegro-v6.2) (ff:def-foreign-call (mus-header-srate "mus_header_srate") (:void) :returning :int)
#+allegro-v7.0 (ff:def-foreign-call (mus-header-srate "mus_header_srate") (:void) :strings-convert t :returning :int)
#+openmcl (defun mus-header-srate () (ccl::external-call "_mus_header_srate" :signed))

#+cmu (def-alien-routine ("mus_header_type" mus-header-type) c-call:int )
#+sbcl (sb-alien:define-alien-routine ("mus_header_type" mus-header-type) sb-alien:int )
#+allegro-v5.0 (ff:def-foreign-call (mus-header-type "mus_header_type") (:void) :returning :int)
#+(or allegro-v6.0 allegro-v6.1 allegro-v6.2) (ff:def-foreign-call (mus-header-type "mus_header_type") (:void) :returning :int)
#+allegro-v7.0 (ff:def-foreign-call (mus-header-type "mus_header_type") (:void) :strings-convert t :returning :int)
#+openmcl (defun mus-header-type () (ccl::external-call "_mus_header_type" :signed))

#+cmu (def-alien-routine ("mus_header_format" mus-header-format) c-call:int )
#+sbcl (sb-alien:define-alien-routine ("mus_header_format" mus-header-format) sb-alien:int )
#+allegro-v5.0 (ff:def-foreign-call (mus-header-format "mus_header_format") (:void) :returning :int)
#+(or allegro-v6.0 allegro-v6.1 allegro-v6.2) (ff:def-foreign-call (mus-header-format "mus_header_format") (:void) :returning :int)
#+allegro-v7.0 (ff:def-foreign-call (mus-header-format "mus_header_format") (:void) :strings-convert t :returning :int)
#+openmcl (defun mus-header-format () (ccl::external-call "_mus_header_format" :signed))

#+cmu (def-alien-routine ("mus_header_comment_start" mus-header-comment-start) c-call:int )
#+sbcl (sb-alien:define-alien-routine ("mus_header_comment_start" mus-header-comment-start) sb-alien:int )
#+allegro-v5.0 (ff:def-foreign-call (mus-header-comment-start "mus_header_comment_start") (:void) :returning :int)
#+(or allegro-v6.0 allegro-v6.1 allegro-v6.2) (ff:def-foreign-call (mus-header-comment-start "mus_header_comment_start") (:void) :returning :int)
#+allegro-v7.0 (ff:def-foreign-call (mus-header-comment-start "clm_header_comment_start") (:void) :strings-convert t :returning :int)
#+openmcl (defun mus-header-comment-start () (ccl::external-call "_mus_header_comment_start" :signed))

#+cmu (def-alien-routine ("mus_header_comment_end" mus-header-comment-end) c-call:int )
#+sbcl (sb-alien:define-alien-routine ("mus_header_comment_end" mus-header-comment-end) sb-alien:int )
#+allegro-v5.0 (ff:def-foreign-call (mus-header-comment-end "mus_header_comment_end") (:void) :returning :int)
#+(or allegro-v6.0 allegro-v6.1 allegro-v6.2) (ff:def-foreign-call (mus-header-comment-end "mus_header_comment_end") (:void) :returning :int)
#+allegro-v7.0 (ff:def-foreign-call (mus-header-comment-end "clm_header_comment_end") (:void) :strings-convert t :returning :int)
#+openmcl (defun mus-header-comment-end () (ccl::external-call "_mus_header_comment_end" :signed))

#+cmu (def-alien-routine ("mus_header_type_specifier" mus-header-type-specifier) c-call:int )
#+sbcl (sb-alien:define-alien-routine ("mus_header_type_specifier" mus-header-type-specifier) sb-alien:int )
#+allegro-v5.0 (ff:def-foreign-call (mus-header-type-specifier "mus_header_type_specifier") (:void) :returning :int)
#+(or allegro-v6.0 allegro-v6.1 allegro-v6.2) (ff:def-foreign-call (mus-header-type-specifier "mus_header_type_specifier") (:void) :returning :int)
#+allegro-v7.0 (ff:def-foreign-call (mus-header-type-specifier "mus_header_type_specifier") (:void) :strings-convert t :returning :int)
#+openmcl (defun mus-header-type-specifier () (ccl::external-call "_mus_header_type_specifier" :signed))

#+cmu (def-alien-routine ("mus_header_bits_per_sample" mus-header-bits-per-sample) c-call:int )
#+sbcl (sb-alien:define-alien-routine ("mus_header_bits_per_sample" mus-header-bits-per-sample) sb-alien:int )
#+allegro-v5.0 (ff:def-foreign-call (mus-header-bits-per-sample "mus_header_bits_per_sample") (:void) :returning :int)
#+(or allegro-v6.0 allegro-v6.1 allegro-v6.2) (ff:def-foreign-call (mus-header-bits-per-sample "mus_header_bits_per_sample") (:void) :returning :int)
#+allegro-v7.0 (ff:def-foreign-call (mus-header-bits-per-sample "mus_header_bits_per_sample") (:void) :strings-convert t :returning :int)
#+openmcl (defun mus-header-bits-per-sample () (ccl::external-call "_mus_header_bits_per_sample" :signed))

#+cmu (def-alien-routine ("mus_header_loop_mode" mus-header-loop-mode) c-call:int (which c-call:int))
#+sbcl (sb-alien:define-alien-routine ("mus_header_loop_mode" mus-header-loop-mode) sb-alien:int (which sb-alien:int))
#+allegro-v5.0 (ff:def-foreign-call (mus-header-loop-mode "mus_header_loop_mode") ((which :int)) :returning :int)
#+(or allegro-v6.0 allegro-v6.1 allegro-v6.2) (ff:def-foreign-call (mus-header-loop-mode "mus_header_loop_mode") ((which :int)) :returning :int)
#+allegro-v7.0 (ff:def-foreign-call (mus-header-loop-mode "mus_header_loop_mode") ((which :int)) :strings-convert t :returning :int)
#+openmcl (defun mus-header-loop-mode (w) (ccl::external-call "_mus_header_loop_mode" :signed w :signed))

#+cmu (def-alien-routine ("mus_header_loop_start" mus-header-loop-start) c-call:int (which c-call:int))
#+sbcl (sb-alien:define-alien-routine ("mus_header_loop_start" mus-header-loop-start) sb-alien:int (which sb-alien:int))
#+allegro-v5.0 (ff:def-foreign-call (mus-header-loop-start "mus_header_loop_start") ((which :int)) :returning :int)
#+(or allegro-v6.0 allegro-v6.1 allegro-v6.2) (ff:def-foreign-call (mus-header-loop-start "mus_header_loop_start") ((which :int)) :returning :int)
#+allegro-v7.0 (ff:def-foreign-call (mus-header-loop-start "mus_header_loop_start") ((which :int)) :strings-convert t :returning :int)
#+openmcl (defun mus-header-loop-start (w) (ccl::external-call "_mus_header_loop_start" :signed w :signed))

#+cmu (def-alien-routine ("mus_header_loop_end" mus-header-loop-end) c-call:int (which c-call:int))
#+sbcl (sb-alien:define-alien-routine ("mus_header_loop_end" mus-header-loop-end) sb-alien:int (which sb-alien:int))
#+allegro-v5.0 (ff:def-foreign-call (mus-header-loop-end "mus_header_loop_end") ((which :int)) :returning :int)
#+(or allegro-v6.0 allegro-v6.1 allegro-v6.2) (ff:def-foreign-call (mus-header-loop-end "mus_header_loop_end") ((which :int)) :returning :int)
#+allegro-v7.0 (ff:def-foreign-call (mus-header-loop-end "mus_header_loop_end") ((which :int)) :strings-convert t :returning :int)
#+openmcl (defun mus-header-loop-end (w) (ccl::external-call "_mus_header_loop_end" :signed w :signed))

#+cmu (def-alien-routine ("mus_header_mark_position" mus-header-mark-position) c-call:int (id c-call:int))
#+sbcl (sb-alien:define-alien-routine ("mus_header_mark_position" mus-header-mark-position) sb-alien:int (id sb-alien:int))
#+allegro-v5.0 (ff:def-foreign-call (mus-header-mark-position "mus_header_mark_position") ((id :int)) :returning :int)
#+(or allegro-v6.0 allegro-v6.1 allegro-v6.2) (ff:def-foreign-call (mus-header-mark-position "mus_header_mark_position") ((id :int)) :returning :int)
#+allegro-v7.0 (ff:def-foreign-call (mus-header-mark-position "mus_header_mark_position") ((id :int)) :strings-convert t :returning :int)
#+openmcl (defun mus-header-mark-position (w) (ccl::external-call "_mus_header_mark_position" :signed w :signed))

#+cmu (def-alien-routine ("mus_header_base_note" mus-header-base-note) c-call:int )
#+sbcl (sb-alien:define-alien-routine ("mus_header_base_note" mus-header-base-note) sb-alien:int )
#+allegro-v5.0 (ff:def-foreign-call (mus-header-base-note "mus_header_base_note") (:void) :returning :int)
#+(or allegro-v6.0 allegro-v6.1 allegro-v6.2) (ff:def-foreign-call (mus-header-base-note "mus_header_base_note") (:void) :returning :int)
#+allegro-v7.0 (ff:def-foreign-call (mus-header-base-note "mus_header_base_note") (:void) :strings-convert t :returning :int)
#+openmcl (defun mus-header-base-note () (ccl::external-call "_mus_header_base_note" :signed))

#+cmu (def-alien-routine ("mus_header_base_detune" mus-header-base-detune) c-call:int )
#+sbcl (sb-alien:define-alien-routine ("mus_header_base_detune" mus-header-base-detune) sb-alien:int )
#+allegro-v5.0 (ff:def-foreign-call (mus-header-base-detune "mus_header_base_detune") (:void) :returning :int)
#+(or allegro-v6.0 allegro-v6.1 allegro-v6.2) (ff:def-foreign-call (mus-header-base-detune "mus_header_base_detune") (:void) :returning :int)
#+allegro-v7.0 (ff:def-foreign-call (mus-header-base-detune "mus_header_base_detune") (:void) :strings-convert t :returning :int)
#+openmcl (defun mus-header-base-detune () (ccl::external-call "_mus_header_base_detune" :signed))

#+cmu (def-alien-routine ("mus_header_set_raw_defaults" mus-header-set-raw-defaults) c-call:void (sr c-call:int) (chn c-call:int) (frm c-call:int))
#+sbcl (sb-alien:define-alien-routine ("mus_header_set_raw_defaults" mus-header-set-raw-defaults) sb-alien:void (sr sb-alien:int) (chn sb-alien:int) (frm sb-alien:int))
#+allegro-v5.0 (ff:def-foreign-call (mus-header-set-raw-defaults "mus_header_set_raw_defaults") ((sr :int) (chn :int) (frm :int)) :returning :void)
#+(or allegro-v6.0 allegro-v6.1 allegro-v6.2) (ff:def-foreign-call (mus-header-set-raw-defaults "mus_header_set_raw_defaults") ((sr :int) (chn :int) (frm :int)) :returning :void)
#+allegro-v7.0 (ff:def-foreign-call (mus-header-set-raw-defaults "mus_header_set_raw_defaults") ((sr :int) (chn :int) (frm :int)) :strings-convert t :returning :void)
#+openmcl (defun mus-header-set-raw-defaults (sr chn frm)
	    (ccl::external-call "_mus_header_set_raw_defaults" :signed sr :signed chn :signed frm :void))

#+cmu (def-alien-routine ("mus_header_true_length" mus-header-true-length) c-call:int )
#+sbcl (sb-alien:define-alien-routine ("mus_header_true_length" mus-header-true-length) sb-alien:int )
#+allegro-v5.0 (ff:def-foreign-call (mus-header-true-length "mus_header_true_length") (:void) :returning :int)
#+(or allegro-v6.0 allegro-v6.1 allegro-v6.2) (ff:def-foreign-call (mus-header-true-length "mus_header_true_length") (:void) :returning :int)
#+allegro-v7.0 (ff:def-foreign-call (mus-header-true-length "clm_header_true_length") (:void) :strings-convert t :returning :int)
#+openmcl (defun mus-header-true-length () (ccl::external-call "_mus_header_true_length" (:signed 64)))

#+cmu (def-alien-routine ("mus_header_original_format" mus-header-original-format) c-call:int )
#+sbcl (sb-alien:define-alien-routine ("mus_header_original_format" mus-header-original-format) sb-alien:int )
#+allegro-v5.0 (ff:def-foreign-call (mus-header-original-format "mus_header_original_format") (:void) :returning :int)
#+(or allegro-v6.0 allegro-v6.1 allegro-v6.2) (ff:def-foreign-call (mus-header-original-format "mus_header_original_format") (:void) :returning :int)
#+allegro-v7.0 (ff:def-foreign-call (mus-header-original-format "mus_header_original_format") (:void) :strings-convert t :returning :int)
#+openmcl (defun mus-header-original-format () (ccl::external-call "_mus_header_original_format" :signed))

#+cmu (def-alien-routine ("mus_samples_to_bytes" mus-samples-to-bytes) c-call:int (format c-call:int) (size c-call:int))
#+sbcl (sb-alien:define-alien-routine ("mus_samples_to_bytes" mus-samples-to-bytes) sb-alien:int (format sb-alien:int) (size sb-alien:int))
#+allegro-v5.0 (ff:def-foreign-call (mus-samples-to-bytes "mus_samples_to_bytes") ((format :int) (size :int)) :returning :int)
#+(or allegro-v6.0 allegro-v6.1 allegro-v6.2) (ff:def-foreign-call (mus-samples-to-bytes "mus_samples_to_bytes") ((format :int) (size :int)) :returning :int)
#+allegro-v7.0 (ff:def-foreign-call (mus-samples-to-bytes "clm_samples_to_bytes") ((format :int) (size :int)) :strings-convert t :returning :int)
#+openmcl (defun mus-samples-to-bytes (frm siz) (ccl::external-call "_mus_samples_to_bytes" :signed frm (:signed 64) siz (:signed 64)))

#+cmu (def-alien-routine ("mus_bytes_to_samples" mus-bytes-to-samples) c-call:int (format c-call:int) (size c-call:int))
#+sbcl (sb-alien:define-alien-routine ("mus_bytes_to_samples" mus-bytes-to-samples) sb-alien:int (format sb-alien:int) (size sb-alien:int))
#+allegro-v5.0 (ff:def-foreign-call (mus-bytes-to-samples "mus_bytes_to_samples") ((format :int) (size :int)) :returning :int)
#+(or allegro-v6.0 allegro-v6.1 allegro-v6.2) (ff:def-foreign-call (mus-bytes-to-samples "mus_bytes_to_samples") ((format :int) (size :int)) :returning :int)
#+allegro-v7.0 (ff:def-foreign-call (mus-bytes-to-samples "clm_bytes_to_samples") ((format :int) (size :int)) :strings-convert t :returning :int)
#+openmcl (defun mus-bytes-to-samples (frm siz) (ccl::external-call "_mus_bytes_to_samples" :signed frm (:signed 64) siz (:signed 64)))

#+cmu (def-alien-routine ("mus_header_write_next_header" mus-header-write-next-header) c-call:int (chan c-call:int) (srate c-call:int) (chans c-call:int) (loc c-call:int) (siz c-call:int) (format c-call:int) (comment c-call:c-string) (len c-call:int))
#+sbcl (sb-alien:define-alien-routine ("mus_header_write_next_header" mus-header-write-next-header) sb-alien:int (chan sb-alien:int) (srate sb-alien:int) (chans sb-alien:int) (loc sb-alien:int) (siz sb-alien:int) (format sb-alien:int) (comment sb-alien:c-string) (len sb-alien:int))
#+allegro-v5.0 (ff:def-foreign-call (mus-header-write-next-header "mus_header_write_next_header")
				    ((chan :int) (srate :int) (chans :int) (loc :int) (siz :int) (format :int) (comment (* :char) string) (len :int))
				    :returning :int)
#+(or allegro-v6.0 allegro-v6.1 allegro-v6.2) (ff:def-foreign-call (mus-header-write-next-header "mus_header_write_next_header")
				    ((chan :int) (srate :int) (chans :int) (loc :int) (siz :int) (format :int) (comment (* :char)) (len :int))
				    :returning :int)
#+allegro-v7.0 (ff:def-foreign-call (mus-header-write-next-header "clm_header_write_next_header")
				    ((chan :int) (srate :int) (chans :int) (loc :int) (siz :int) (format :int) (comment (* :char)) (len :int))
				    :strings-convert t :returning :int)
#+openmcl (defun mus-header-write-next-header (fd srate chans loc size format comment len)
	    (ccl:with-cstrs ((c comment))
              (ccl::external-call "_mus_header_write_next_header" :signed fd :signed srate :signed chans
				  (:signed 64) loc (:signed 64) size :signed format :address c :signed len
				  :signed)))

#+cmu (def-alien-routine ("mus_header_read" mus-header-read) c-call:int (name c-call:c-string))
#+sbcl (sb-alien:define-alien-routine ("mus_header_read" mus-header-read) sb-alien:int (name sb-alien:c-string))
#+allegro-v5.0 (ff:def-foreign-call (mus-header-read "mus_header_read") ((name (* :char) string)) :returning :int)
#+(or allegro-v6.0 allegro-v6.1 allegro-v6.2) (ff:def-foreign-call (mus-header-read "mus_header_read") ((name (* :char))) :returning :int)
#+allegro-v7.0 (ff:def-foreign-call (mus-header-read "mus_header_read") ((name (* :char))) :strings-convert t :returning :int)
#+openmcl (defun mus-header-read (name) (ccl:with-cstrs ((f name)) (ccl::external-call "_mus_header_read" :address f :signed)))

#+cmu (def-alien-routine ("mus_header_write" mus-header-write) c-call:int
	(name c-call:c-string) (type c-call:int) (srate c-call:int) (chans c-call:int) (loc c-call:int) (size c-call:int) (format c-call:int) (comment c-call:c-string) (len c-call:int))
#+sbcl (sb-alien:define-alien-routine ("mus_header_write" mus-header-write) sb-alien:int
	(name sb-alien:c-string) (type sb-alien:int) (srate sb-alien:int) (chans sb-alien:int) (loc sb-alien:int) (size sb-alien:int) (format sb-alien:int) (comment sb-alien:c-string) (len sb-alien:int))
#+allegro-v5.0 (ff:def-foreign-call (mus-header-write "mus_header_write")
				    ((name (* :char) string) (type :int) (srate :int) (chans :int) (loc :int) (size :int)
				     (format :int) (comment (* :char) string) (len :int))
				    :returning :int)
#+(or allegro-v6.0 allegro-v6.1 allegro-v6.2) (ff:def-foreign-call (mus-header-write "mus_header_write")
				    ((name (* :char)) (type :int) (srate :int) (chans :int) (loc :int) (size :int) (format :int)
				     (comment (* :char)) (len :int))
				    :returning :int)
#+allegro-v7.0 (ff:def-foreign-call (mus-header-write "mus_header_write")
				    ((name (* :char)) (type :int) (srate :int) (chans :int) (loc :int) (size :int) (format :int)
				     (comment (* :char)) (len :int))
				    :strings-convert t :returning :int)
#+openmcl (defun mus-header-write (name type srate chans loc size format comment len)
	    (ccl:with-cstrs ((f name) (c comment))
              (ccl::external-call "_mus_header_write" :address f :signed type :signed srate :signed chans
				  (:signed 64) loc (:signed 64) size :signed format :address c :signed len
				  :signed)))

#+cmu (def-alien-routine ("mus_header_aux_comment_start" mus-header-aux-comment-start) c-call:int (n c-call:int))
#+sbcl (sb-alien:define-alien-routine ("mus_header_aux_comment_start" mus-header-aux-comment-start) sb-alien:int (n sb-alien:int))
#+allegro-v5.0 (ff:def-foreign-call (mus-header-aux-comment-start "mus_header_aux_comment_start") ((n :int)) :returning :int)
#+(or allegro-v6.0 allegro-v6.1 allegro-v6.2) (ff:def-foreign-call (mus-header-aux-comment-start "mus_header_aux_comment_start") ((n :int)) :returning :int)
#+allegro-v7.0 (ff:def-foreign-call (mus-header-aux-comment-start "clm_header_aux_comment_start") ((n :int)) :strings-convert t :returning :int)
#+openmcl (defun mus-header-aux-comment-start (n) (ccl::external-call "_mus_header_aux_comment_start" :signed n :signed))

#+cmu (def-alien-routine ("mus_header_aux_comment_end" mus-header-aux-comment-end) c-call:int (n c-call:int))
#+sbcl (sb-alien:define-alien-routine ("mus_header_aux_comment_end" mus-header-aux-comment-end) sb-alien:int (n sb-alien:int))
#+allegro-v5.0 (ff:def-foreign-call (mus-header-aux-comment-end "mus_header_aux_comment_end") ((n :int)) :returning :int)
#+(or allegro-v6.0 allegro-v6.1 allegro-v6.2) (ff:def-foreign-call (mus-header-aux-comment-end "mus_header_aux_comment_end") ((n :int)) :returning :int)
#+allegro-v7.0 (ff:def-foreign-call (mus-header-aux-comment-end "clm_header_aux_comment_end") ((n :int)) :strings-convert t :returning :int)
#+openmcl (defun mus-header-aux-comment-end (n) (ccl::external-call "_mus_header_aux_comment_end" :signed n :signed))

#+cmu (def-alien-routine ("mus_header_initialize" mus-header-initialize) c-call:int )
#+sbcl (sb-alien:define-alien-routine ("mus_header_initialize" mus-header-initialize) sb-alien:int )
#+allegro-v5.0 (ff:def-foreign-call (mus-header-initialize "mus_header_initialize") (:void) :returning :int)
#+(or allegro-v6.0 allegro-v6.1 allegro-v6.2) (ff:def-foreign-call (mus-header-initialize "mus_header_initialize") (:void) :returning :int)
#+allegro-v7.0 (ff:def-foreign-call (mus-header-initialize "mus_header_initialize") (:void) :strings-convert t :returning :int)
#+openmcl (defun mus-header-initialize () (ccl::external-call "_mus_header_initialize" :signed))

#+cmu (def-alien-routine ("mus_header_writable" mus-header-writable) c-call:int (type c-call:int) (format c-call:int))
#+sbcl (sb-alien:define-alien-routine ("mus_header_writable" mus-header-writable) sb-alien:int (type sb-alien:int) (format sb-alien:int))
#+allegro-v5.0 (ff:def-foreign-call (mus-header-writable "mus_header_writable") ((type :int) (format :int)) :returning :int)
#+(or allegro-v6.0 allegro-v6.1 allegro-v6.2) (ff:def-foreign-call (mus-header-writable "mus_header_writable") ((type :int) (format :int)) :returning :int)
#+allegro-v7.0 (ff:def-foreign-call (mus-header-writable "mus_header_writable") ((type :int) (format :int)) :strings-convert t :returning :int)
#+openmcl (defun mus-header-writable (typ frm) (ccl::external-call "_mus_header_writable" :signed typ :signed frm :signed))

#+cmu (def-alien-routine ("mus_header_sf2_entries" mus-header-sf2-entries) c-call:int )
#+sbcl (sb-alien:define-alien-routine ("mus_header_sf2_entries" mus-header-sf2-entries) sb-alien:int )
#+allegro-v5.0 (ff:def-foreign-call (mus-header-sf2-entries "mus_header_sf2_entries") (:void) :returning :int)
#+(or allegro-v6.0 allegro-v6.1 allegro-v6.2) (ff:def-foreign-call (mus-header-sf2-entries "mus_header_sf2_entries") (:void) :returning :int)
#+allegro-v7.0 (ff:def-foreign-call (mus-header-sf2-entries "mus_header_sf2_entries") (:void) :strings-convert t :returning :int)
#+openmcl (defun mus-header-sf2-entries () (ccl::external-call "_mus_header_sf2_entries" :signed))

#+cmu (def-alien-routine ("mus_header_sf2_name" mus-header-sf2-name) c-call:c-string (n c-call:int))
#+sbcl (sb-alien:define-alien-routine ("mus_header_sf2_name" mus-header-sf2-name) sb-alien:c-string (n sb-alien:int))
#+allegro-v5.0 (ff:def-foreign-call (mus-header-sf2-name-1 "mus_header_sf2_name") ((n :int)) :returning :int)
#+allegro-v5.0 (defun mus-header-sf2-name (name) (let ((ptr (mus-header-sf2-name-1 name))) (ff:char*-to-string ptr)))
#+(or allegro-v6.0 allegro-v6.1 allegro-v6.2) (ff:def-foreign-call (mus-header-sf2-name "mus_header_sf2_name") ((n :int)) :returning ((* :char)))
#+allegro-v7.0 (ff:def-foreign-call (mus-header-sf2-name "mus_header_sf2_name") ((n :int)) :strings-convert t :returning ((* :char)))
#+openmcl (defun mus-header-sf2-name (n) (get-cstring (ccl::external-call "_mus_header_sf2_name" :signed n :address)))

#+cmu (def-alien-routine ("mus_header_sf2_start" mus-header-sf2-start) c-call:int (n c-call:int))
#+sbcl (sb-alien:define-alien-routine ("mus_header_sf2_start" mus-header-sf2-start) sb-alien:int (n sb-alien:int))
#+allegro-v5.0 (ff:def-foreign-call (mus-header-sf2-start "mus_header_sf2_start") ((n :int)) :returning :int)
#+(or allegro-v6.0 allegro-v6.1 allegro-v6.2) (ff:def-foreign-call (mus-header-sf2-start "mus_header_sf2_start") ((n :int)) :returning :int)
#+allegro-v7.0 (ff:def-foreign-call (mus-header-sf2-start "mus_header_sf2_start") ((n :int)) :strings-convert t :returning :int)
#+openmcl (defun mus-header-sf2-start (n) (ccl::external-call "_mus_header_sf2_start" :signed n :signed))

#+cmu (def-alien-routine ("mus_header_sf2_end" mus-header-sf2-end) c-call:int (n c-call:int))
#+sbcl (sb-alien:define-alien-routine ("mus_header_sf2_end" mus-header-sf2-end) sb-alien:int (n sb-alien:int))
#+allegro-v5.0 (ff:def-foreign-call (mus-header-sf2-end "mus_header_sf2_end") ((n :int)) :returning :int)
#+(or allegro-v6.0 allegro-v6.1 allegro-v6.2) (ff:def-foreign-call (mus-header-sf2-end "mus_header_sf2_end") ((n :int)) :returning :int)
#+allegro-v7.0 (ff:def-foreign-call (mus-header-sf2-end "mus_header_sf2_end") ((n :int)) :strings-convert t :returning :int)
#+openmcl (defun mus-header-sf2-end (n) (ccl::external-call "_mus_header_sf2_end" :signed n :signed))

#+cmu (def-alien-routine ("mus_header_sf2_loop_start" mus-header-sf2-loop-start) c-call:int (n c-call:int))
#+sbcl (sb-alien:define-alien-routine ("mus_header_sf2_loop_start" mus-header-sf2-loop-start) sb-alien:int (n sb-alien:int))
#+allegro-v5.0 (ff:def-foreign-call (mus-header-sf2-loop-start "mus_header_sf2_loop_start") ((n :int)) :returning :int)
#+(or allegro-v6.0 allegro-v6.1 allegro-v6.2) (ff:def-foreign-call (mus-header-sf2-loop-start "mus_header_sf2_loop_start") ((n :int)) :returning :int)
#+allegro-v7.0 (ff:def-foreign-call (mus-header-sf2-loop-start "mus_header_sf2_loop_start") ((n :int)) :strings-convert t :returning :int)
#+openmcl (defun mus-header-sf2-loop-start (n) (ccl::external-call "_mus_header_sf2_loop_start" :signed n :signed))

#+cmu (def-alien-routine ("mus_header_sf2_loop_end" mus-header-sf2-loop-end) c-call:int (n c-call:int))
#+sbcl (sb-alien:define-alien-routine ("mus_header_sf2_loop_end" mus-header-sf2-loop-end) sb-alien:int (n sb-alien:int))
#+allegro-v5.0 (ff:def-foreign-call (mus-header-sf2-loop-end "mus_header_sf2_loop_end") ((n :int)) :returning :int)
#+(or allegro-v6.0 allegro-v6.1 allegro-v6.2) (ff:def-foreign-call (mus-header-sf2-loop-end "mus_header_sf2_loop_end") ((n :int)) :returning :int)
#+allegro-v7.0 (ff:def-foreign-call (mus-header-sf2-loop-end "mus_header_sf2_loop_end") ((n :int)) :strings-convert t :returning :int)
#+openmcl (defun mus-header-sf2-loop-end (n) (ccl::external-call "_mus_header_sf2_loop_end" :signed n :signed))

#+cmu (def-alien-routine ("mus_header_original_format_name" mus-header-original-format-name) c-call:c-string (format c-call:int) (type c-call:int))
#+sbcl (sb-alien:define-alien-routine ("mus_header_original_format_name" mus-header-original-format-name) sb-alien:c-string (format sb-alien:int) (type sb-alien:int))
#+allegro-v5.0 (ff:def-foreign-call (mus-header-original-format-name-1 "mus_header_original_format_name")
				    ((format :int) (type :int)) :returning :int)
#+allegro-v5.0 (defun mus-header-original-format-name (a b) (let ((ptr (mus-header-original-format-name-1 a b))) (ff:char*-to-string ptr)))
#+(or allegro-v6.0 allegro-v6.1 allegro-v6.2) (ff:def-foreign-call (mus-header-original-format-name "mus_header_original_format_name")
				    ((format :int) (type :int)) :returning ((* :char)))
#+allegro-v7.0 (ff:def-foreign-call (mus-header-original-format-name "mus_header_original_format_name")
				    ((format :int) (type :int)) :strings-convert t :returning ((* :char)))
#+openmcl (defun mus-header-original-format-name (format type)
	    (get-cstring (ccl::external-call "_mus_header_original_format_name" :signed format :signed type :address)))

#|
;;; here's some of the relevant translation code:
(defun c->lisp (name)
  (string-downcase (substitute-if #\- #'(lambda (n) (char= n #\_)) name)))

(defun cmucl-mangle-args (args)
  (if args
      (format nil "~{(~A ~A) ~}"
	      (loop for type in args by #'cddr and
		name in (cdr args) by #'cddr
		collect (c->lisp (symbol-name name))
		collect (if (eq type 'char*)
			    "c-string"
			  (if (eq type 'Float)
			      "double-float"
			    (if (find #\* (symbol-name type) :test #'char=)
				(format nil "(* ~A)"
					(string-downcase (remove-if (lambda (n) (char= n #\*)) (symbol-name type))))
			      (string-downcase (symbol-name type)))))))))

(defun acl6-mangle-args (args)
  (if (or (not args)
	  (eq (car args) 'void))
      ":void"
    (format nil
	    "~{(~A ~A) ~}"
	    (loop for type in args by #'cddr and
	              name in (cdr args) by #'cddr
	      collect (c->lisp (symbol-name name))
	      collect (if (eq type 'char*)
			  "(* :char)"
			(if (find #\* (symbol-name type) :test #'char=)
			    (format nil
				    "(* :~A) array"
				    (string-downcase (remove-if (lambda (n) (char= n #\*)) (symbol-name type))))
			  (format nil
				  ":~A"
				  (string-downcase (symbol-name type)))))))))
	    
(defun acl5-mangle-args (args)
  (if (or (not args)
	  (eq (car args) 'void))
      ":void"
    (format nil
	    "~{(~A ~A) ~}"
	    (loop for type in args by #'cddr and
	              name in (cdr args) by #'cddr
	      collect (c->lisp (symbol-name name))
	      collect (if (eq type 'char*)
			  "(* :char) string"
			(if (find #\* (symbol-name type) :test #'char=)
			    (format nil
				    "(* :~A) array"
				    (string-downcase (remove-if (lambda (n) (char= n #\*)) (symbol-name type))))
			  (format nil
				  ":~A"
				  (string-downcase (symbol-name type)))))))))
	    
(defun translate-ffi (file c-type c-name &rest args)
  ;; args is list of c-type argname
  (format file
	  "#+cmu (def-alien-routine (~S ~A) ~A ~A)~%"
	 sbcl+csb-alien:mu ine(def-alien-routine (~S ~A) ~A ~A)~%"
	  (string-downcase (symbol-name c-name))
	  (c->lisp (symbol-name c-name))
	  (if (eq c-type 'char*)
	      "c-string"
	    (if (eq c-type 'Float)
		"double-float"
	      (string-downcase (symbol-name c-type))))
	  (cmucl-mangle-args args))
  (format file
	  "#+allegro-v5.0 (ff:def-foreign-call (~A~A ~S) (~A) :returning ~A)~%"
	  (c->lisp (symbol-name c-name))
	  (if (find #\* (symbol-name c-type) :test #'char=) "-1" "")
	  (string-downcase (symbol-name c-name))
	  (acl5-mangle-args args)
	  (if (find #\* (symbol-name c-type) :test #'char=)
	      (format nil
		      ":int"
		      (string-downcase (remove-if (lambda (n) (char= n #\*)) (symbol-name c-type))))
	    (format nil
		    ":~A"
		    (string-downcase (symbol-name c-type)))))
  (if (find #\* (symbol-name c-type) :test #'char=)
      (format file
	      "#+allegro-v5.0 (defun ~A (name) (let ((ptr (~A-1 name))) (ff:char*-to-string ptr)))~%"
	      (c->lisp (symbol-name c-name))
	      (c->lisp (symbol-name c-name))))
  (format file
	  "#+(or allegro-v6.0 allegro-v6.1 allegro-v6.2) (ff:def-foreign-call (~A ~S) (~A) :returning ~A)~%"
	  (c->lisp (symbol-name c-name))
	  (string-downcase (symbol-name c-name))
	  (acl6-mangle-args args)
	  (if (find #\* (symbol-name c-type) :test #'char=)
	      (format nil
		      "((* :~A))"
		      (string-downcase (remove-if (lambda (n) (char= n #\*)) (symbol-name c-type))))
	    (format nil
		    ":~A"
		    (string-downcase (symbol-name c-type)))))
  (format file "~%")
  )

(with-open-file (file "test.clm" :direction :output :if-exists :supersede :if-does-not-exist :create)
  (format file "#+excl (require :foreign)~%#+cmu (use-package \"ALIEN\")~%#+cmu (use-package \"C-CALL\")~%~%")
  sbclrmsb-alien:at inefile "#+excl (require :foreign)~%#+cmu (use-package \"ALIEN\")~%#+cmu (use-package \"C-CALL\")~%~%")

(translate-ffi file 'char* 'mus_error_to_string 'int 'err)
;;; and so on
)
|#
